(function (context) {

    if (context.UCReadabilityContext) { return; }
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //全局变量定义
    var global_const = {
        qualify_point_min_threshold  : 1600, //ReaderMinimumScore
        max_readability_detection_ms : 1000,
        tags_not_qualified_article   : ["A", "EMBED", "FORM", "HTML", "IFRAME", "OBJECT", "OL", "OPTION", "SCRIPT", "STYLE", "SVG", "UL"],
        tags_not_contain_text : ["A", "DD", "DT", "NOSCRIPT", "OL", "OPTION", "PRE", "SCRIPT", "STYLE", "TD", "UL"], //usableTextNodesInElement tagNamesToIgnore
        text_element_search_x_path_query : "text()|*/text()|*/a/text()|*/li/text()|*/span/text()|*/em/text()|*/i/text()|*/strong/text()|*/b/text()|*/font/text()|blockquote/*/text()|div[count(./p)=count(./*)]/p/text()", //usableTextNodesInElement xPathQuery
        qualified_article_min_width  : 280,
        qualified_article_min_height : 295,
        qualified_article_min_area   : 170000,
        qualified_article_max_offset : 1300,
        document_position_contained_by : 16, //DocumentPositionContainedBy

        min_portion_for_indicator_elements : 0.5, //        CandidateMinimumWidthPortionForIndicatorElements

        default_font_size : 16, //BaseFontSize
        height_ratio_with_base_line : 1.125, //BaseLineHeightRatio

        qualified_article_min_list_item_line_count : 4, //CandidateMinumumListItemLineCount

        text_node_min_length : 20,
        text_node_length_point_factor : 1.25,

        max_char_for_language_detect : 12, //DefaultNumberOfTextNodesToCheckForLanguageMultiplier
        max_text_node_for_language_detect : 3, //NumberOfCharactersPerTextNodeToEvaluateForLanguageMultiplier
        cjk_language_char_ratio_threshold : 0.5,//MinimumRatioOfCharactersForLanguageMultiplier
        cjk_language_point_factor : 3, //ScoreMultiplierForChineseJapaneseKorean

        article_like_regex : /(?:(?:^|\s)(?:(post|hentry|entry)[-_]?(?:content|text|body)?|article[-_]?(?:content|text|body|page)?)(?:\s|$))/i,
        article_like_bonus : 0.5, //ArticleMatchBonus
        comment_like_regex : /comment|meta|footer|footnote/,
        comment_like_penalty : 0.75,  //CommentMatchPenalty,

        article_min_text_intensity_factor : 4.25, //ArticleMinimumScoreDensity
        article_text_exclude_element_selector : "#disqus_thread, #comments, .userComments",
        article_media_child_selector : "img, object, video",
        article_min_hr_average_interval : 400, //MinimumAverageDistanceBetweenHRElements
        article_min_header_average_interval : 400, //MinimumAverageDistanceBetweenHeaderElements
        header_element_x_path_query : "(h1|h2|h3|h4|h5|h6|*/h1|*/h2|*/h3|*/h4|*/h5|*/h6)[a]", //headerLinksXPathQuery
        header_check_inset_ratio : 0.1, //PortionOfCandidateHeightToIgnoreForHeaderCheck
        article_max_media_area_factor : 0.2,//MaximumContentImageAreaToArticleAreaRatio
        article_min_media_width_factor : 0.5,//MinimumContentImageWidthToArticleWidthRatio
        article_min_media_height : 200, //MinimumContentImageHeight


        //optimize
        tags_not_readability : ["FORM", "IFRAME", "SCRIPT", "STYLE", "LINK"], //tagNamesToAlwaysPrune
        title_min_interval_with_article_content : 200, //HeaderMinimumDistanceFromArticleTop
        title_similarity_threshold : 0.75, //HeaderLevenshteinDistanceToLengthRatio
        elements_should_wrap_in_paragraph_selector : "a, blockquote, dl, div, img, ol, p, pre, table, ul",
        float_element_min_height_threshold : 130,//    FloatMinimumHeight
        readability_unnecessary_attributes_regex : /^on|^id$|^class$|^style$/, //AttributesToRemoveRegEx
        tags_change_font_style : ["I", "EM"],
        tags_change_font_weight : ["B", "STRONG", "H1", "H2", "H3", "H4", "H5", "H6"], //tagNamesAffectingFontStyle

        readability_unnecessary_image_attributes : ["border", "hspace", "vspace", "align"],
        readability_large_image_width_factor : 0.5, //ImageSizeTiny
        readability_small_image_size_threshold : 32, //ImageWidthToParentWidthRatio

        readability_a_image_min_width : 100, //AnchorImageMinimumWidth
        readability_a_image_min_height : 100,//AnchorImageMinimumHeight
        readability_suspend_tags : ["DIV", "TABLE", "OBJECT", "UL", "CANVAS", "P", "IFRAME", "ASIDE", "SECTION", "FOOTER", "NAV", "OL"], //tagNamesToConsiderPruning
        readability_unnecessary_font_attributes : ["size", "face", "color"],
        known_lazy_image_loading_attributes : ["original", "data-original", "data-src", "src2", "data-lazy-src", "original-src", "rel:bf_image_src"],

        readability_positive_regex : /article|body|content|entry|hentry|page|pagination|post|text/i,
        readability_negative_regex : /breadcrumb|combx|comment|contact|disqus|foot|footer|footnote|link|media|meta|mod-conversations|promo|related|scroll|share|shoutbox|sidebar|social|sponsor|tags|toolbox|widget/i,

        ///// title
        title_max_distance : 500,   // HeaderMaximumDistance
        title_min_font_size : 20,   // HeaderMinimumFontSize
        title_min_text_length : 8,  // HeaderMinimumTextLength
        title_font_size_min_ratio  : 1.1,  // HeaderFontSizeBonusMinimumRatio
        title_font_size_mul  :  1.25,      // HeaderFontSizeBonusMultiplier
        title_extra_scope_regex  :  /header|title|headline|instapaper_title/i,   // HeaderBonusRegEx
        title_regex_mul : 1.5,  // HeaderRegexBonusMultiplier , HeaderContentBonusMultiplier
        class_name_filter_regex  : /byline|author/i,   /// regex
        title_min_dom_distance  :  9,   /// HeaderMaximumDOMDistance
        title_font_size_min_diff  : 1.5,  /// HeaderMinimumFontSizeDifference
        similarity_min_value      : 0.97,

        ///TTS每段最大长度
        tts_paragraph_max_length : 300
    };

    var global_env = {
        enable_log : 0, //发布应设置为0
        disable_article_find_timeout : 0, //发布应设置为0
        elements_with_bounding_cached : [],
        current_scroll_x : 0,
        current_scroll_y : 0
    };
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   /**
    * @constructor
    */
    var UCArticleNodeOptimizeContext = function () {
        this._inside_float_element = 0;
        this._inside_table_element = 0;
        this._inside_font_style_element = 0;
        this._inside_font_weight_element = 0;
    };

    UCArticleNodeOptimizeContext.prototype.moveContextWithLevelDelt = function (move_delta) {
        if (this._inside_float_element) this._inside_float_element += move_delta;
        if (this._inside_table_element) this._inside_table_element += move_delta;
        if (this._inside_font_style_element) this._inside_font_style_element += move_delta;
        if (this._inside_font_weight_element) this._inside_font_weight_element += move_delta;
    };

    UCArticleNodeOptimizeContext.prototype.moveContextToSibling = function () {
        if (this._inside_float_element === 1) this._inside_float_element = 0;
        if (this._inside_table_element === 1) this._inside_table_element = 0;
        if (this._inside_font_style_element === 1) this._inside_font_style_element = 0;
        if (this._inside_font_weight_element === 1) this._inside_font_weight_element = 0;
    };

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //工具类方法定义
    var utils = {};
    utils.log = function (description) {
        if (global_env.enable_log) {
            console.log("UCReadability: " + description);
        }
    };

    utils.nodeDescription = function (node) {
        if (!global_env.enable_log) {
            return '';
        }

        if (!node) {
            return "node is null";
        }

        var rv = node.nodeName + " ";
        if (node.nodeType == node.TEXT_NODE) {
            return rv + '("' + node.textContent + '")';
        }
        var classDesc = node.className && ("." + node.className.replace(/ /g, "."));
        var elDesc = "";
        if (node.id)
            elDesc = "(#" + node.id + classDesc + ")";
        else if (classDesc)
            elDesc = "(" + classDesc + ")";
        return rv + elDesc;
    };

    utils.isElementHasClass = function (element, className) {
        if (!className) return false;
        if (element.className === className) return true;
        var index = element.className.indexOf(className);
        if (index === -1) return false;
        var toTest = " " + element.className + " ";
        return toTest.indexOf(" " + className + " ", index) !== -1;
    };

    utils.addElementClass = function (element, className) {
        if (className && !utils.isElementHasClass(element, className)) element.className += (element.className.length ? " " + className : className);
    };

    utils.wrapElementInBlock = function (element) {

        var blockElement = element;
        const NeedWrapBlockElements = {"P" : 1}; //如果为非块元素，封装到DIV中
        if (element && element.tagName in NeedWrapBlockElements) {
            var wrapper = document.createElement("div");
            wrapper.appendChild(element);
            blockElement = wrapper;
        }

        return blockElement;
    };


    utils.boundingRectOfElement = function (element) {
      var bounds = element.getBoundingClientRect();

      if (!global_env.current_scroll_x && !global_env.current_scroll_y) {
        element._uc_cached_bounds = bounds;
      } else {
          var r = bounds.right + global_env.current_scroll_x;
          var t = bounds.top + global_env.current_scroll_y;
          var b = bounds.bottom + global_env.current_scroll_y;
          var l = bounds.left + global_env.current_scroll_x;

          element._uc_cached_bounds = {top : t, right: r, bottom : b, left: l, width : bounds.width, height : bounds.height};
      }

      global_env.elements_with_bounding_cached.push(element);

      return element._uc_cached_bounds;
    };

    utils.cleanAllBoundingCache = function () {
        var allElements = global_env.elements_with_bounding_cached;
        var allElementsCount = allElements ? allElements.length : 0;
        for (var i=0; i< allElementsCount; i++) {
            allElements[i]._uc_cached_bounds = null;
        }

        global_env.elements_with_bounding_cached = [];
    };

    utils.computedFontSize = function (style, default_size) { //fontSizeFromComputedStyle
        var fontSize = parseInt(style.fontSize, 10);
        if (isNaN(fontSize)) fontSize = default_size ? default_size : global_const.default_font_size;
        return fontSize;
    };

    utils.isEmptyTextNode = function (node) {
        if (!node || node.nodeType !== Node.TEXT_NODE) return false;
        return !/\S/.test(node.data);
    };

    utils.stripAllWhitespace = function(string) {
        if (!string ) {
            return "";
        }

        return string.replace(/\s+/g, '');
    };

    utils.gradeTextNode = function (text_node, owner) { //rawScoreForTextNode
        if (!text_node) {
            return 0;
        }

        var length = text_node.length;
        if (length < global_const.text_node_min_length){ //小于TextNodeMinimumLength不得分
            return 0;
        }

        var ancestor = text_node.parentNode;
        if (!utils.isElementVisible(ancestor))//父节点不可见不得分
        {
            return 0;
        }

        var multiplier = 1; //得分系数默认为1，每多一层父元素，得分系数减0.1
        while (ancestor && ancestor !== owner)
        {
            multiplier -= 0.1;
            ancestor = ancestor.parentNode;
        }

        return Math.pow(length * multiplier, global_const.text_node_length_point_factor); //长度 * 得分系数 的 TextNodeLengthPower（1.25） 次幂
    };

    utils.mostChildWithSameStyles = function (element) //childrenWithParallelStructure
    {
        var all_child = element.children;
        if (!all_child) return [];
        var all_child_count = all_child.length;
        if (!all_child_count) return [];

        var class_nodes_map = {};
        for (var i = 0; i < all_child_count; ++i) {

            var one_child = all_child[i];

            if (global_const.tags_not_qualified_article.indexOf(one_child.tagName) !== -1 || !one_child.className) {
                continue;
            }

            var child_class_list = one_child.classList;
            var class_name_count = child_class_list.length;
            for (var a = 0; a < class_name_count; ++a) {
                var one_class_name = child_class_list[a];
                var record_ = class_nodes_map[one_class_name];
                if (record_) {
                    record_.push(one_child);
                }
                else {
                    class_nodes_map[one_class_name] = [one_child];
                }
            }
        }

        var half_of_child_count = Math.floor(all_child_count / 2);
        for (var a_class_name in class_nodes_map) {
            var node_list_for_a_class = class_nodes_map[a_class_name];
            if (node_list_for_a_class.length > half_of_child_count) {
                return node_list_for_a_class;
            }
        }

        return [];
    };

    utils.getAllTextNode = function (element, content_document) {
      if (!element || !content_document ) {
          return [];
      }

      var text_nodes = [];
      var x_path_results = content_document.evaluate(global_const.text_element_search_x_path_query, element, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
      for (var i = 0; i< x_path_results.snapshotLength; i++) {
          var node = x_path_results.snapshotItem(i);
          if (!node._uc_temp_flag_text_node_get_all && utils.isValidTextNode(node)) {
              text_nodes.push(node);
              node._uc_temp_flag_text_node_get_all = true;
          }
      }

      return text_nodes;
    };


    utils.isValidTextNode = function (node) {
        if (!node) {
            return false;
        }

        var parentTagName = node.parentNode ? node.parentNode.tagName : null;
        if (global_const.tags_not_contain_text.indexOf(parentTagName) !== -1) {
            return false;
        }

        if (utils.isEmptyTextNode(node)) {
            return false;
        }

        return true;
    };


    utils.isElementVisible = function (element) {
        if (!element) {
            return false;
        }

        if ( !utils.boundingRectOfElement(element).height ) {
            return false;
        }

        var style = getComputedStyle(element);
        if (style.visibility !== "visible" || style.display ==="none") {
            return false;
        }

        return true;
    };

    utils.isCJKChar = function (detect_char) { //characterNeedsScoreMultiplier

        if (!detect_char || detect_char.length === 0) {
            return false;
        }

        var characterCode = detect_char.charCodeAt(0);

        var is_cjk_char = true;
        do {

            if (characterCode > 11904 && characterCode < 12031) { break; }
            if (characterCode > 12352 && characterCode < 12543) { break; }
            if (characterCode > 12736 && characterCode < 19903) { break; }
            if (characterCode > 19968 && characterCode < 40959) { break; }
            if (characterCode > 44032 && characterCode < 55215) { break; }
            if (characterCode > 63744 && characterCode < 64255) { break; }
            if (characterCode > 65072 && characterCode < 65103) { break; }
            if (characterCode > 131072 && characterCode < 173791) { break; }
            if (characterCode > 194560 && characterCode < 195103) { break; }

            is_cjk_char = false;
        } while (0);

        return is_cjk_char;
    };

    utils.textNodeLanguagePointFactor = function (total_text_nodes) { //中日韩文系数为3， 其它为1
        if (!total_text_nodes || !total_text_nodes.length) {
            return 1;
        }

        var max_node_detect = Math.min(total_text_nodes.length, global_const.max_text_node_for_language_detect);

        var cjk_char_count = 0;
        var total_char_detect = 0;
        for (var i = 0; i < max_node_detect; i++)
        {
            var node_value = total_text_nodes[i].nodeValue.trim();
            var max_char_detect = Math.min(node_value.length, global_const.max_char_for_language_detect);

            for (var u = 0; u < max_char_detect; u++) {
                if (utils.isCJKChar(node_value[u])) {
                    cjk_char_count++;
                }
            }

            total_char_detect += max_char_detect;
        }

        return cjk_char_count >= total_char_detect * global_const.cjk_language_char_ratio_threshold ? global_const.cjk_language_point_factor : 1
    };

    utils.elementPropertyPointFactor = function (element) { //scoreMultiplierForElementTagNameAndAttributes
        var property_factor = 1;
        for (var n = element; n; n = n.parentElement)
        {
            var r = n.getAttribute("id");
            if (r)
            {
                if (global_const.article_like_regex.test(r)) {
                    property_factor += global_const.article_like_bonus;
                }

                if (global_const.comment_like_regex.test(r)) {
                    property_factor -= global_const.comment_like_penalty;
                }
            }

            var i = n.className;
            if (i)
            {
                if (global_const.article_like_regex.test(i)) {
                    property_factor += global_const.article_like_bonus;
                }

                if (global_const.comment_like_regex.test(i)) {
                    property_factor -= global_const.comment_like_penalty;
                }
            }

            if (n.tagName === "ARTICLE"){ //tagName为ARTICLE，得分系数加0.5
                property_factor += global_const.article_like_bonus;
            }
        }

        return Math.max(0, property_factor);
    };

    utils.elementDepth = function (element) {
        var depth = 0;
        while (element) {
            element = element.parentElement;
            depth++;
        }

        return depth;
    };

    utils.firstAncestorElementWithTagName =function (element, tag) {
        while (element = element.parentElement)
            if (element.tagName === tag) return element;
        return null
    };

    utils.levenshteinDistance = function (string1, string2) {
        var len1 = string1.length;
        var len2 = string2.length;
        var d = new Array(len1 + 1);
        for (var i = 0; i < len1 + 1; i++) {
            d[i] = new Array(len2 + 1);
            d[i][0] = i;
        }
        for (var j = 0; j < len2 + 1; j++)
            d[0][j] = j;
        for (var j = 1; j < len2 + 1; j++) {
            for (var i = 1; i < len1 + 1; i++) {
                if (string1[i - 1] === string2[j - 1])
                    d[i][j] = d[i - 1][j - 1];
                else {
                    var deletion = d[i - 1][j] + 1;
                    var insertion = d[i][j - 1] + 1;
                    var substitution = d[i - 1][j - 1] + 1;
                    d[i][j] = Math.min(deletion, insertion, substitution);
                }
            }
        }
        return d[len1][len2];
    };

    utils.stringSimilarity = function (string1, string2) {
        var maxLength = Math.max(string1.length, string2.length);
        return maxLength ? (maxLength - utils.levenshteinDistance(string1, string2)) / maxLength : 0;
    };

    utils.stringsAreNearlyIdentical = function (string1, string2) {
        return string1 === string2 ? !0 : utils.stringSimilarity(string1, string2) > global_const.similarity_min_value;
    };

    utils.isHostAndPathnameEqualToDocumentLocation = function(element, location) {
        return (element.host === location.host && element.pathname === location.pathname)
    };

    utils.innerTextOrTextContentOfElement = function (element) {
        var text = element.innerText;
        if (!text)
            text = element.textContent;
        return text;
    };

    utils.isPrefixOrSuffix = function (header_text, document_title) {
       var position = header_text ? document_title.indexOf(header_text) : -1;
       return (position !== -1 && (position === 0 || position + header_text.length === document_title.length));
    };

    utils.articleTitleAndSiteNameFromSuspendTitleString = function (title_string, contentDocument) {
       const t = [" - ", " \u2013 ", " \u2014 ", ": ", " | ", " \u00bb "];
       const count = t.length;
       const ratio = .6;
       var i = contentDocument.location.host,
           s = i.replace(/^(www|m)\./, ""),
           o = s.replace(/\.(com|info|net|org|edu)$/, "").toLowerCase(),
           u, a;
       for (var f = 0; f < count; ++f)
       {
           var l = title_string.split(t[f]);
           if (l.length !== 2) continue;
           var c = l[0].trim(),
               h = l[1].trim(),
               p = c.toLowerCase(),
               d = h.toLowerCase(),
               v = Math.max(utils.stringSimilarity(p, s), utils.stringSimilarity(p, o)),
               m = Math.max(utils.stringSimilarity(d, s), utils.stringSimilarity(d, o)),
               g = Math.max(v, m);
           if (!a || g > a) a = g, v > m ? u = {
               siteName: c,
               articleTitle: h
           } : u = {
               siteName: h,
               articleTitle: c
           }
       }
       return u && a >= ratio ? u : null
    };

   // 满足title候选条件的meta标签
   utils.suspendTitleFromMetaTag = function (meta_content, document) {

       var element = document.querySelector(meta_content);
       var content = element && element.attributes.length === 2 ? element.content : null;
       if (content)
       {
           var r = utils.articleTitleAndSiteNameFromSuspendTitleString(content, document);
           r && (content = r.articleTitle)
       }

       return content;
   };

   utils.contentTextStyleForNode = function(contentDocument, node, searchInReverse) {

       function getComputedStyleIfNodeIsBodyText(textNode) {
           if (utils.isEmptyTextNode(textNode)) return null;
           var style = getComputedStyle(textNode.parentNode);
           if (style.float !== "none") return null;
           return style;
       };

       var nonHeaderTextXPathQuery = "descendant::text()[not(parent::h1) and not(parent::h2) and not(parent::h3) and not(parent::h4) and not(parent::h5) and not(parent::h6)]";
       var articleTextNodes = contentDocument.evaluate(nonHeaderTextXPathQuery, node, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
       if (searchInReverse) {
           for (var nodeIndex = articleTextNodes.snapshotLength - 1; nodeIndex >= 0; nodeIndex--) {
               var style = getComputedStyleIfNodeIsBodyText(articleTextNodes.snapshotItem(nodeIndex));
               if (style) return style;
           }
        } else {
           for (var nodeIndex = 0; nodeIndex < articleTextNodes.snapshotLength; nodeIndex++) {
               var style = getComputedStyleIfNodeIsBodyText(articleTextNodes.snapshotItem(nodeIndex));
               if (style) return style;
           }
        }
        return null;
   };

   utils.domDistance = function (elementA, elementB, distanceCap) {
       var ancestorsA = [];
       var node = elementA;
       while (node) {
           ancestorsA.unshift(node);
           node = node.parentNode;
       }
       var ancestorsB = [];
       node = elementB;
       while (node) {
           ancestorsB.unshift(node);
           node = node.parentNode;
       }
       var shallowerDepth = Math.min(ancestorsA.length, ancestorsB.length);
       var domDistance = Math.abs(ancestorsA.length - ancestorsB.length);
       for (var i = shallowerDepth; i >= 0; i--) {
           if (ancestorsA[i] === ancestorsB[i]) break;
           domDistance += 2;
           if (distanceCap && domDistance >= distanceCap) return distanceCap;
       }
       return domDistance;
   };

    utils.isCommentLikeElement = function (element) {
        if ( !element ) {
            return false;
        }

        if (/(^|\s)comment/.test(element.className)) {
            return true;
        }

        var attributes = element.getAttribute("id");
        if (attributes && attributes.indexOf("comment") === 0) {
            return true;
        }

        return false;
    };

    utils.isReadabilityTagName = function (tag_name) {
        if (!tag_name) {
            return false;
        }

        return global_const.tags_not_readability.indexOf(tag_name.toUpperCase()) === -1;
    };

    utils.getTextContext = function(element) {
        var text = element.innerText;
        if (!text) text = element.textContent;
        return text;
    };

    utils.isNonStandardLink = function (href) {
        return href && href.length && (href[0] === "#" || href.substring(0, 11) === "javascript:");
    };

    utils.replaceElement = function (element_original, element_replacement) {
        if (!element_original || !element_original.parentNode || ! element_replacement ) {
            return element_original;
        }

        while (element_original.firstChild)
            element_replacement.appendChild(element_original.firstChild);

        element_original.parentNode.replaceChild(element_replacement, element_original);

        return element_replacement;
    };

    utils.statementsSegmentationLessThan = function (node, limit) {
        var count = 0;
        var textContent = node.textContent;
        var i = -1;
        while (count < limit && (i = textContent.indexOf(',', i + 1)) >= 0)
            count++;
        return count < limit;
    };

    utils.isElementDescendantOf = function (element, tagName) {
        var node = element;
        while (node.parentNode) {
            node = node.parentNode;
            if (node.tagName === tagName) return true;
        }
        return false;
    };

    utils.calculateLinkDensity = function (element) {
        var textLength = utils.stripAllWhitespace(element.textContent).length;
        if (!textLength) return 0;
        var links = element.querySelectorAll("a");
        var linkCharacterCount = 0;
        for (var i = 0; i < links.length; i++)
            linkCharacterCount += utils.stripAllWhitespace(links[i].textContent).length;
        return linkCharacterCount / textLength;
    };
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //满足条件的候选节点
   /**
    * @constructor
    */
    var QualifiedArticle = function(element, contentDocument) {
        this._bindingElement = element;
        this._contentDocument = contentDocument;

        this._all_text_nodes = this.allTextNodeInElement(element);

        //评分体系
        this._raw_point = this.grade();
        this._language_point_factor = 0;
        this._property_point_factor = -1;

        utils.log("construct new qualified article object with text node " + this._all_text_nodes.length + "; raw point " + this._raw_point);
    };

    /*给当前节点进行文本基础评分*/
    QualifiedArticle.prototype.grade = function () { //calculateRawScore
        var total_point = 0;
        var text_node_count = this._all_text_nodes.length;

        for (var i=0; i<text_node_count; i++) {
            total_point += utils.gradeTextNode(this._all_text_nodes[i], this._bindingElement);
        }

        return total_point;
    };

    QualifiedArticle.prototype.languagePointFactor = function () {
      if ( !this._language_point_factor ) {
          this._language_point_factor = utils.textNodeLanguagePointFactor(this._all_text_nodes);
      }

      return this._language_point_factor;
    };

    QualifiedArticle.prototype.propertyPointFactor = function () {
        if (this._property_point_factor === -1) {
            this._property_point_factor = utils.elementPropertyPointFactor(this._bindingElement);
        }

        return this._property_point_factor;
    };

    QualifiedArticle.prototype.basicPoint = function () {
        return this.rawPoint() * this.propertyPointFactor();
    };

    QualifiedArticle.prototype.rawPoint = function () {
        return this._raw_point;
    };

    QualifiedArticle.prototype.finalPoint = function () {
        return this.basicPoint() * this.languagePointFactor();
    };

    QualifiedArticle.prototype.commentLikeElementArea = function () {

        var comment_like_element_area = 0;
        var all_child_nodes = this._bindingElement.children || [];
        var child_node_count = all_child_nodes.length;

        for (var s = 0; s < child_node_count; ++s) {
            var one_child = all_child_nodes[s];
            if (utils.isCommentLikeElement(one_child)) {
                comment_like_element_area += one_child.clientHeight * one_child.clientWidth;
            }
        }

        return comment_like_element_area;
    };

    QualifiedArticle.prototype.mediaElementArea = function (media_min_width, media_max_area) {

        var media_element_area = 0;

        var all_media_nodes = this._bindingElement.querySelectorAll("img, object, video");
        var media_node_count = all_media_nodes.length;

        for (var s = 0; s < media_node_count; ++s) {
            var media_node_bounds = utils.boundingRectOfElement(all_media_nodes[s]);
            if (media_node_bounds.width >= media_min_width && media_node_bounds.height > global_const.article_min_media_height) {
                var valid_media_area = media_node_bounds.width * media_node_bounds.height;
                if (valid_media_area < media_max_area) {
                    media_element_area += valid_media_area;
                }
            }
        }

        return media_element_area;
    };

    /*文本密集度*/
    QualifiedArticle.prototype.textIntensityFactor = function () {//scoreDensity
        var ignored_area = 0;

        //这部分处理应该是针对特定站点页面的
        var ignoredElement = this._bindingElement.querySelector(global_const.article_text_exclude_element_selector);
        if (ignoredElement) {
            ignored_area = ignoredElement.clientWidth * ignoredElement.clientHeight;
        }

        //计算commentLike区域
        ignored_area += this.commentLikeElementArea();


        var article_bounds = utils.boundingRectOfElement(this._bindingElement);
        var qualified_article_area = article_bounds.width * article_bounds.height;

        var media_max_area = qualified_article_area * global_const.article_max_media_area_factor;
        var media_min_width = article_bounds.width * global_const.article_min_media_width_factor;

        //计算媒体元素区域
        ignored_area += this.mediaElementArea(media_min_width, media_max_area);

        var node_basic_point = this.basicPoint();
        var text_area = qualified_article_area - ignored_area;
        var numberOfTextNodes = this._all_text_nodes.length;
        var numberOfCountedTextNodes = 0;
        var sum_of_font_sizes = 0;
        for (var i = 0; i < numberOfTextNodes; i++) {
            var parent_element = this._all_text_nodes[i].parentElement;
            if (parent_element) {
                sum_of_font_sizes += utils.computedFontSize(getComputedStyle(parent_element), null);
                numberOfCountedTextNodes++;
            }
        }

        var average_font_size = global_const.default_font_size;
        if (numberOfCountedTextNodes){
            average_font_size = sum_of_font_sizes / numberOfCountedTextNodes;
        }

        var text_intensity_factor =  (node_basic_point / text_area * 1000) * (average_font_size / global_const.default_font_size) * this.languagePointFactor();
        utils.log("text_intensity_factor: " + text_intensity_factor + "; node_basic_point: " + node_basic_point + "; text_area: " + text_area + "; average_font_size: " + average_font_size);

        return text_intensity_factor;
    };

    QualifiedArticle.prototype.isLooseTextNode = function () {
        var text_intensity_factor = this.textIntensityFactor();
        if (text_intensity_factor < global_const.article_min_text_intensity_factor) {//文本密度过底时，不满足进入阅读模式的条件

            utils.log("text intensity factor is " + text_intensity_factor + ", min intensity factor require is " + global_const.article_min_text_intensity_factor);
            return true;
        }

        return false;
    };

    QualifiedArticle.prototype.isListLikeTextNode = function () { //
        var all_hr_nodes = this._bindingElement.getElementsByTagName("hr"); //水平分割线
        var hr_node_count = all_hr_nodes.length;

        var long_horizontal_line_count = 0;
        var element_bounds = utils.boundingRectOfElement(this._bindingElement);

        var long_horizontal_line_threshold = element_bounds.width * .7;
        for (var o = 0; o < hr_node_count; ++o)
        {
            if (all_hr_nodes[o].clientWidth > long_horizontal_line_threshold) {
                long_horizontal_line_count++;
            }
        }

        if (long_horizontal_line_count)
        {
            var average_hr_interval = element_bounds.height / long_horizontal_line_count;
            if (average_hr_interval < global_const.article_min_hr_average_interval)
            {
                return true;
            }
        }

        return false;
    };

    QualifiedArticle.prototype.isUnfocusedTextNode = function () { //判断标题密度 shouldDisqualifyDueToHeaderDensity

        var headerLinkResults = this._contentDocument.evaluate(global_const.header_element_x_path_query, this._bindingElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
        if (headerLinkResults.snapshotLength > 2) {
            var numberOfHeadersToCount = 0;
            var elementRect = utils.boundingRectOfElement(this._bindingElement);
            var topBottomIgnoreDistance = elementRect.height * global_const.header_check_inset_ratio;

            for (var i = 0; i < headerLinkResults.snapshotLength; i++) {
                var header = headerLinkResults.snapshotItem(i);
                var headerRect = utils.boundingRectOfElement(header);
                if (headerRect.top - elementRect.top > topBottomIgnoreDistance && elementRect.bottom - headerRect.bottom > topBottomIgnoreDistance) numberOfHeadersToCount++;
            }

            var averageDistanceBetweenHeaders = elementRect.height / numberOfHeadersToCount;
            if (averageDistanceBetweenHeaders < global_const.article_min_header_average_interval){
                return true;
            }
        }

        return false;
    };

    QualifiedArticle.prototype.allTextNodeInElement = function (element) {//usableTextNodesInElement

        var all_text_nodes = [];
        if ( !element ) {
            return all_text_nodes;
        }

        var direct_text_nodes = utils.getAllTextNode(element, this._contentDocument);
        all_text_nodes = all_text_nodes.concat(direct_text_nodes);

        utils.log("element " + utils.nodeDescription(element) + " has direct text node " + all_text_nodes.length);

        var same_style_child = utils.mostChildWithSameStyles(element);
        var same_style_child_count = same_style_child.length;
        utils.log("element " + utils.nodeDescription(element) + " has same style child " + same_style_child_count);

        for (var i=0; i< same_style_child_count; i++) {
            var sub_text_nodes = utils.getAllTextNode(same_style_child[i], this._contentDocument);

            all_text_nodes = all_text_nodes.concat(sub_text_nodes);
        }

        var all_text_node_count = all_text_nodes.length;
        for (var j = 0; j<all_text_node_count; j++) {
            all_text_nodes[j]._uc_temp_flag_text_node_get_all = null;
        }

        utils.log("element " + utils.nodeDescription(element) + " final text node " + all_text_nodes.length);
        return all_text_nodes;
    };


    QualifiedArticle.prototype.grabTextNodeFromDescendant = function (other_qualified_node) { //addTextNodesFromCandidateElement
        for (var i = 0; i<this._all_text_nodes.length; i++) {
            this._all_text_nodes[i]._uc_temp_flag_text_node_grab = true;
        }

        var other_all_text_nodes = other_qualified_node._all_text_nodes;
        for (var i = 0; i<other_all_text_nodes.length; i++) {
            if (!other_all_text_nodes[i]._uc_temp_flag_text_node_grab) {
                this._all_text_nodes.push(other_all_text_nodes[i]);
            }
        }

        for (var i = 0; i<this._all_text_nodes.length; i++) {
            this._all_text_nodes[i]._uc_temp_flag_text_node_grab = null;
        }

        this._raw_point = this.grade();
    };

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   /**
    * @constructor
    */
    var UCReadability = function (contentDocument) {
        this._contentDocument = contentDocument;

        this._hasRunReadabilityDetect = false;
        this._topQualifiedArticle = null;

        this._readabilityArticleElement = null;

        this._readabilityTitle = null;
        this._cachedContentTextStyle = null,

        this.pageNumber = 1; //页面码



        this._hasReadDirectionDetected = false;
        this._isReadDirectionLTR = true;

    };

    UCReadability.prototype.isReadDirectionLTR = function () {
        if (!this._hasReadDirectionDetected)
        {
            var style = getComputedStyle(this._topQualifiedArticle._bindingElement);
            if (style) {
                this._isReadDirectionLTR = style.direction === "ltr";
            }

            this._hasReadDirectionDetected = true;
        }

        return this._isReadDirectionLTR;
    };

    UCReadability.prototype.isElementQualifiedForArticle = function (element, contentDocument, isForSimilarClass) {
        if (!element || !element.tagName) {
            return false;
        }

        var tagName = element.tagName.toUpperCase();
        if (global_const.tags_not_qualified_article.indexOf(tagName) !== -1) {
            return false;
        }

        var bounds = utils.boundingRectOfElement(element);
        if (isForSimilarClass) {
            return true;
        }

        if (!bounds) {
            utils.log("bounds is undef for element :" + utils.nodeDescription(element));
            return false;
        }

        if (bounds.width < global_const.qualified_article_min_width || bounds.height < global_const.qualified_article_min_height){
            return false;
        }

        if (bounds.width * bounds.height < global_const.qualified_article_min_area) {
            return false;
        }

        if (bounds.top > global_const.qualified_article_max_offset) {
            return false;
        }

        if (this.reasonableElementHeight(element) < global_const.qualified_article_min_height) {
            return false;
        }

        return true;
    };

    UCReadability.prototype.correctedHeightForForm = function (element, bounds) {
        //如果内部包含form且form的高度大于当前元素的一半，则该候选元素的高度为减去form后的高度

        var correctedHeight = 0;

        var indicatorElements = element.querySelectorAll("form");
        for (var i = 0; i < indicatorElements.length; i++)
        {
            var indicatorElement = indicatorElements[i];
            var indicatorRect = utils.boundingRectOfElement(indicatorElement);

            if (indicatorRect.width > bounds.width * global_const.min_portion_for_indicator_elements)
            {
                correctedHeight -= indicatorRect.height;
            }
        }

        return correctedHeight;
    };

    UCReadability.prototype.correctedHeightForTable = function (element, bounds) {

        var correctedHeight = 0;
        //如果内部包含宽高比较大的表格元素，则该候选元素的高度为减去不及格后的高度
        var listContainers = element.querySelectorAll("ol, ul");
        var listContainersCount = listContainers.length;
        var lastListContainerSubstracted = null;
        for (var i = 0; i < listContainersCount; i++)
        {
            var listContainer = listContainers[i];
            if (lastListContainerSubstracted && lastListContainerSubstracted.compareDocumentPosition(listContainer) & global_const.document_position_contained_by) {
                continue;
            }

            var listItems = listContainer.querySelectorAll("li");
            var listItemCount = listItems.length;
            var listRect = utils.boundingRectOfElement(listContainer);
            if (!listItemCount)
            {
                correctedHeight -= listRect.height;
                continue;
            }

            var averageListItemHeight = listRect.height / listItemCount;
            var firstListItemStyle = getComputedStyle(listItems[0]);
            var listLineHeight = parseInt(firstListItemStyle.lineHeight, 10);
            if (isNaN(listLineHeight))
            {
                var listFontSize = utils.computedFontSize(firstListItemStyle, null);
                listLineHeight = listFontSize * global_const.height_ratio_with_base_line;
            }

            if (listRect.width > bounds.width * global_const.min_portion_for_indicator_elements && ((averageListItemHeight / listLineHeight) < global_const.qualified_article_min_list_item_line_count))
            {
                correctedHeight -= listRect.height;
                lastListContainerSubstracted = listContainer;
            }
        }

        return correctedHeight;
    };

    UCReadability.prototype.reasonableElementHeight = function (element) {
        var bounds = utils.boundingRectOfElement(element);
        var reasonableHeight = bounds.height;

        reasonableHeight += this.correctedHeightForForm(element, bounds);
        reasonableHeight += this.correctedHeightForTable(element, bounds);

        return reasonableHeight;
    };


    UCReadability.prototype.associateBlockQuoteToTheirAncestor = function (all_qualified_nodes) {
        for (var i = 0; i < all_qualified_nodes.length; i++)
        {
            all_qualified_nodes[i]._bindingElement._uc_temp_qualified_node = all_qualified_nodes[i];
        }

        for (var i = 0; i < all_qualified_nodes.length; i++) //遍历所有候选元素
        {
            var qualified_node = all_qualified_nodes[i];
            if (qualified_node._bindingElement.tagName !== "BLOCKQUOTE") continue; //处理所有tagName为BLOCKQUOTE的候选元素

            var parent_qualified_node = qualified_node._bindingElement.parentElement._uc_temp_qualified_node; //找到tagName为BLOCKQUOTE的父节点
            if (!parent_qualified_node) continue;

            parent_qualified_node.grabTextNodeFromDescendant(qualified_node); //如果父节点也是候选元素，将tagName为BLOCKQUOTE的候选元素附加到父节点上
        }

        for (var i = 0; i < all_qualified_nodes.length; i++)
        {
            all_qualified_nodes[i]._bindingElement._uc_temp_qualified_node = null;
        }
    };

    UCReadability.prototype.findAllQualifiedArticleNodes  = function () { //所有满足条件的候选节点 //findCandidateElements
        var expired_time = Date.now() + global_const.max_readability_detection_ms;

        var all_elements = this._contentDocument.getElementsByTagName("*");
        utils.log("all element check is : " + all_elements.length);

        var all_qualified_nodes = [];
        for (var i = 0; i< all_elements.length; i++) {
            var element = all_elements[i];
            if (this.isElementQualifiedForArticle(element, this._contentDocument, false)) {
                all_qualified_nodes.push(new QualifiedArticle(element, this._contentDocument));
            }

        }

        this.associateBlockQuoteToTheirAncestor(all_qualified_nodes);

        return all_qualified_nodes;
    };

    UCReadability.prototype.findQualifiedArticleNodeViaHint = function () { //TODO:imp
        return null;
    };

    UCReadability.prototype.findQualifiedArticleNodeWithHighestPoint = function (allQualifiedNodes) {
        var highestPoint = 0;
        var highestPointNode = null;

        for (var i = 0; i < allQualifiedNodes.length; i++) {
            var currentNode = allQualifiedNodes[i];
            var point = currentNode.basicPoint();
            if (point >= highestPoint) {
                highestPoint = point;
                highestPointNode = currentNode;
            }
        }

        return highestPointNode;
    };

    UCReadability.prototype.expandBlockQuoteQualifiedNode = function (qualified_node, all_qualified_nodes) {

        var expand_block_quote_node = qualified_node;
        for (var bindingElement = qualified_node._bindingElement; bindingElement !== this._contentDocument; bindingElement = bindingElement.parentNode)
        {
            if (bindingElement.tagName === "BLOCKQUOTE")
            {
                var blockQuoteParentNode = bindingElement.parentNode;

                var allQualifiedNodesCount = all_qualified_nodes.length;
                for (var i=0; i< allQualifiedNodesCount; i++) {
                    var qualifiedNode = all_qualified_nodes[i];
                    if (qualifiedNode._bindingElement === blockQuoteParentNode) {
                        expand_block_quote_node = qualifiedNode;
                        break;
                    }
                }

                break;
            }
        }

        return expand_block_quote_node;
    };

    UCReadability.prototype.calculateTopQualifiedArticleNode = function () { //findArticleBySearchingAllElements
        var qualifiedNodeFromHint = this.findQualifiedArticleNodeViaHint();
        var allQualifiedNodes = this.findAllQualifiedArticleNodes();

        utils.log("total qualified article node count is:" + allQualifiedNodes.length);
        if (!allQualifiedNodes || !allQualifiedNodes.length)
        {
            utils.log("no qualified article node found, return node from hint :" + (qualifiedNodeFromHint ? utils.nodeDescription(qualifiedNodeFromHint._bindingElement) : "none"));
            return qualifiedNodeFromHint;
        }

        if (qualifiedNodeFromHint && qualifiedNodeFromHint.basicPoint() >= global_const.qualify_point_min_threshold)
        {
            utils.log("node from hint basic point is match, return :" + utils.nodeDescription(qualifiedNodeFromHint._bindingElement));
            return qualifiedNodeFromHint;
        }

        var highestPointNode = this.findQualifiedArticleNodeWithHighestPoint(allQualifiedNodes);
        highestPointNode = this.expandBlockQuoteQualifiedNode(highestPointNode, allQualifiedNodes);

        utils.log("highest point node is :" + (highestPointNode ? utils.nodeDescription(highestPointNode._bindingElement) : "none") + "; raw point is: " + highestPointNode.rawPoint());
        if (qualifiedNodeFromHint && highestPointNode.finalPoint() < global_const.qualify_point_min_threshold) {
            utils.log("highest point node not match, return :" + (qualifiedNodeFromHint ? utils.nodeDescription(qualifiedNodeFromHint._bindingElement) : "none"));
            return qualifiedNodeFromHint;
        }

        do {
            if ( !highestPointNode ) {
                break;
            }

            if (highestPointNode.isLooseTextNode()) {

                utils.log("highest point node is disqualified due to loose text node check");
                highestPointNode = null;
                break;
            }

            if (highestPointNode.isListLikeTextNode()) {
                utils.log("highest point node is disqualified due to list like check");
                highestPointNode = null;
                break;
            }

            if (highestPointNode.isUnfocusedTextNode()) {
                utils.log("highest point node is disqualified due to header density check");
                highestPointNode = null;
                break;
            }

        } while(0);

        utils.log("final highest point node is :" + (highestPointNode ? utils.nodeDescription(highestPointNode._bindingElement) :  "none "));
        return highestPointNode ;
    };

    //查找最合适的候选节点
    UCReadability.prototype.findTopQualifiedArticleElement = function () { //articleNode()
        if (!this._hasRunReadabilityDetect) {
            this._topQualifiedArticle = this.calculateTopQualifiedArticleNode();
            utils.log("final article element: " + utils.nodeDescription(this._topQualifiedArticle && this._topQualifiedArticle._bindingElement));
            this._hasRunReadabilityDetect = true;
        }

        return this._topQualifiedArticle ? this._topQualifiedArticle._bindingElement : null;
    };

    UCReadability.prototype.allTextContentArray = function () { //articleNode()
        var ret = [];
        if (this._topQualifiedArticle) {
            this._topQualifiedArticle._all_text_nodes.forEach(function(item){
                ret.push(item.textContent.trim());
            })
        }

        return JSON.stringify(ret);
    };
    /// articleTitle
    UCReadability.prototype.contentTextStyle = function () {
        if (this._cachedContentTextStyle)
            return this._cachedContentTextStyle;

        this._cachedContentTextStyle = utils.contentTextStyleForNode(this._contentDocument, this.findTopQualifiedArticleElement(), false);

        if (!this._cachedContentTextStyle)
        {
            this._cachedContentTextStyle = getComputedStyle(this.findTopQualifiedArticleElement())
        }

        return this._cachedContentTextStyle;
    };

    UCReadability.prototype.isElementHasUniqueDC_Title = function (element) {
        var property = element.getAttribute("property");
        if (property) {
            var matchGroups = /dc.title/i.exec(property);
            if (matchGroups && matchGroups[0]) {
                var ot = this._contentDocument.querySelectorAll('*[property~="' + matchGroups[0] + '"]');
                if (ot.length === 1) {
                    return true;
                }
            }
        }

        return false;
    };

    UCReadability.prototype.isHeaderElementSuitable = function (headerElement, metaResultHeaders) {

        var isEqualToMetaHeader = metaResultHeaders.indexOf(headerElement) !== -1,
            /// 猜测是instapaper站点离线缓存过的网页，会添加该class
            isContainClass = headerElement.classList.contains("instapaper_title"),
            isMatchAttribute = headerElement.getAttribute("itemprop") === "headline";

        return  isEqualToMetaHeader || isContainClass || isMatchAttribute;
    };

    //查找到合适的Title
    UCReadability.prototype.findQualifiedArticleNodeTitle = function () {

        if (!this.findTopQualifiedArticleElement())
            return ;
        if (this._readabilityTitle)
            return this._readabilityTitle;

        var allHeaders = this.qualifiedArticleTitleElementFromTagScope();
        var document_title = this._contentDocument.title;
        var meta_title = utils.suspendTitleFromMetaTag("head meta[property='og:title']",this._contentDocument);

        var arr = this.optimizeQualifiedArticleTitleElementBySimilarity(allHeaders, meta_title);
        var resultHeaders = arr[0], metaResultHeaders = arr[1];

        var bestHeader;
        if (metaResultHeaders.length === 1) {
            bestHeader = metaResultHeaders[0];
            bestHeader.headerText = utils.innerTextOrTextContentOfElement(bestHeader);
            utils.log("bestHeader element from metaResultHeaders...,bestHeader element: " + utils.nodeDescription(bestHeader));
        }

        if (!bestHeader) {
            bestHeader = this.findHighestScoreArticleTitleElement(allHeaders,resultHeaders, metaResultHeaders);
            utils.log("bestHeader element from allHeaders...,bestHeader element: " + utils.nodeDescription(bestHeader));
        }

        if (bestHeader) {
            var ht = parseInt(this.contentTextStyle().fontSize, 10);
            var domDistance = utils.domDistance(bestHeader, this.findTopQualifiedArticleElement(), global_const.title_min_dom_distance + 1);
            var diff = parseInt(getComputedStyle(bestHeader).fontSize, 10);

            if (domDistance > global_const.title_min_dom_distance && diff < global_const.title_font_size_min_diff * ht) {
                bestHeader = null;
            } else {
                // this._articleTitleElement = bestHeader;
                var title = bestHeader.headerText.trim();
                if (meta_title && utils.isPrefixOrSuffix(meta_title, title)) {
                    this._readabilityTitle = meta_title;
                } else if (document_title && utils.isPrefixOrSuffix(document_title, title)){
                    this._readabilityTitle = document_title;
                } else {
                    this._readabilityTitle = title;
                }

                return this._readabilityTitle;
            }
        }

        if (meta_title && utils.isPrefixOrSuffix(meta_title, document_title)) {
            this._readabilityTitle = meta_title;
        } else {
            this._readabilityTitle = document_title;
        }

        return this._readabilityTitle;
    };


    UCReadability.prototype.isElementRedundantWithTitleElement = function (original_article_node, clone_article_node, original_article_node_offset) {
        if (!clone_article_node || !original_article_node ) {
            utils.log("is element redundant with title element : invalid param");
            return false;
        }

        if (["H1", "H2"].indexOf(clone_article_node.tagName) !== -1) {
            if (original_article_node_offset < global_const.title_min_interval_with_article_content) {
                var headerText = utils.getTextContext(clone_article_node);
                var maxDistanceToConsiderSimilar = headerText.length * global_const.title_similarity_threshold;
                if (utils.levenshteinDistance(this.readabilityTitle(), headerText) <= maxDistanceToConsiderSimilar) {
                    utils.log("is element redundant with title element : same due to levenshtein distance");
                    return true;
                }
            }
        }

        return false;
    };

    /**
     * Takes in a DOM element and returns all of its text content.
     * https://github.com/koalatiapp/extract-dom-content
     *
     * @param {Element} originalNode - DOM element to get the content from.
     * @param {Object} [options={}] - An object of options to apply additionals filters and/or change the return type.
     * @param {boolean} [options.returnAsArray=false] - Whether the content should be returned as a linebreak-separated string or an array of strings.
     * @param {boolean} [options.removeDuplicates=false] - Whether duplicate strings should be removed or kept.
     * @return {String|Array}
     */

     utils.extractDomContent = function (originalNode, options = {}) {
        const mainNode = originalNode.cloneNode(true);
        const allOriginalNodes = originalNode.querySelectorAll('*');
        const allClonedNodes = mainNode.querySelectorAll('*');

        // Apply computed styles as inline CSS for every node, as window.getComputedStyle isn't available outside the DOM
        for (let i = 0; i < allOriginalNodes.length; i++) {
            allClonedNodes[i].setAttribute('style', window.getComputedStyle(allOriginalNodes[i]).cssText);
        }

        // Get rid of unwanted elements for copy text
        for (const unwantedNode of mainNode.querySelectorAll('script, style, noscript, code')) {
            unwantedNode.remove();
        }

        // Prevent <br> from causing stuck-together words
        for (const brNode of mainNode.querySelectorAll('br')) {
            brNode.outerHTML = brNode.nextSibling && brNode.nextSibling.nodeValue && brNode.nextSibling.nodeValue.trim().length ? ' ' : '\n';
        }

        // Replace images with their alt text if they have one
//        for (const imgNode of mainNode.querySelectorAll('img[alt]:not([alt=""])')) {
//            imgNode.outerHTML = '\n' + imgNode.alt + '\n';
//        }

        // Flex, block or grid display links with that only contain text can most likely be on their own line
        for (const linkNode of mainNode.querySelectorAll('a')) {
            const display = linkNode.style.display.toLowerCase();
            if (display == 'block' || display.indexOf('flex') != -1 || display.indexOf('grid') != -1) {
                if (![...linkNode.childNodes].filter((node) => { return node.nodeName != '#text'; }).length) {
                    linkNode.innerHTML = "\n\n" + linkNode.innerHTML;
                }
            }
        }

        // Flex childs are rarely words forming a sentence: break them apart
        for (const node of mainNode.querySelectorAll('*')) {
            if (node.style.display.toLowerCase().indexOf('flex') != -1) {
                for (const child of node.children) {
                    child.innerHTML = "\n\n" + child.innerHTML;
                }
            }
        }

        // Simple fix for minified HTML
        mainNode.innerHTML = mainNode.innerHTML.replace(/></g, '> <');

        // Make sure headings are on their own lines - they should be "self-sufficient"
        mainNode.innerHTML = mainNode.innerHTML.replace(/<h([1-6])(.+?)<\/h\1>/g, '\n<h$1$2</h1>\n');

        // Home stretch...
        const rawContent = (mainNode.innerText || mainNode.textContent || '')
            .replace(/(\s{2,})([A-Z0-9])/g, '$1\n$2') // split blocks that seem to contain multiple sentences or standalone blocks
            .replace(/\s{3,}/g, '\n') // break everything into single line blocks
            .replace(/\n.{1,3}\n/g, '\n') // remove tiny words or tokens that are on their own
            .replace(/ {2,}/g, ' ') // replace multiple spaces by a single one
            .replace(/^\s(.+)$/gm, '$1'); // remove spaces at the beginning of lines

        if (options.removeDuplicates || false) {
            // Get an array of strings without duplicates via the Set constructor and spread operator
            let contentStrings = [...new Set(rawContent.split('\n'))];

            if (options.returnAsArray || false) {
                return contentStrings;
            }

            return contentStrings.join('\n');
        } else if (options.returnAsArray || false) {
            return rawContent.split('\n');
        }

        return rawContent;
    }

    //从设定的tag范围中获取title候选节点列表
    UCReadability.prototype.qualifiedArticleTitleElementFromTagScope = function () {
        // 筛选设定范围标签的element
        var tagScope = "h1, h2, h3, h4, h5, .headline, .article_title, #hn-headline, .inside-head, .instapaper_title";
        var articleElement = this.findTopQualifiedArticleElement();


        var articleTagName = articleElement.tagName;
        if (articleTagName === 'DL' || articleTagName === 'DD')
            tagScope += ", dt";

        var allHeaders = this._contentDocument.querySelectorAll(tagScope);
        allHeaders = Array.prototype.slice.call(allHeaders, 0);

        // 筛选合适a标签的element添加到候选列表
        var loc = this._contentDocument.location, aElements = articleElement.getElementsByTagName("a");
        for (var i = 0; i < aElements.length; i++) {
            var aElement = aElements[i];
            var articleOffsetTop = this.findTopQualifiedArticleElement().offsetTop + global_const.title_min_font_size;
            if (aElement.offsetTop > articleOffsetTop)
                break;

            if (utils.isHostAndPathnameEqualToDocumentLocation(aElement, loc)) {
                utils.log("has a tag element candidate...");
                utils.log("candidate a-tag element: " + utils.nodeDescription(aElement));
                allHeaders.push(aElement);
                break;
            }
        }

        return allHeaders;
    };

    UCReadability.prototype.wrapBlockTextIntoParagraph = function (original_article_node, clone_article_node, node_computed_style, optimize_context) {
        if (!original_article_node || !clone_article_node || !node_computed_style || !optimize_context) {
            return clone_article_node;
        }

        if (clone_article_node.tagName.toUpperCase() !== "DIV") {
            return clone_article_node;
        }

        if ( optimize_context._inside_float_element || node_computed_style["float"] !== "none") {
            return clone_article_node;
        }

        var elements_should_wrap_in_paragraph = original_article_node.querySelectorAll(global_const.elements_should_wrap_in_paragraph_selector);
        if ( !elements_should_wrap_in_paragraph.length ) {
            return clone_article_node;
        }

        var replacement_node = this._contentDocument.createElement("p");
        replacement_node._uc_original_element = original_article_node;
        replacement_node = utils.replaceElement(clone_article_node, replacement_node);

        utils.log("wrap elements in div into p element...");
        return replacement_node;
    };

    UCReadability.prototype.updateNodeOptimizeContext = function (current_original_node, current_clone_node, original_article_node, clone_article_node, current_original_node_computed_style, optimize_context) {
        if (!current_original_node_computed_style) {
            return optimize_context;
        }

        var tag_name = current_clone_node.tagName.toUpperCase();

        if (current_original_node !== original_article_node
            && tag_name !== "IMG"
            && !optimize_context._inside_float_element
            && current_original_node_computed_style["float"] !== "none"
            && (utils.boundingRectOfElement(current_original_node).height >= global_const.float_element_min_height_threshold || current_original_node.childElementCount > 1)) {
            optimize_context._inside_float_element = 1;
        }

        if (!optimize_context._inside_font_style_element && current_original_node_computed_style.fontStyle !== "normal") {
            if (global_const.tags_change_font_style.indexOf(tag_name) !== -1) {
                current_clone_node.style.fontStyle = current_original_node_computed_style.fontStyle;
            }

            optimize_context._inside_font_style_element = 1;
        }

        if (!optimize_context._inside_font_weight_element && current_original_node_computed_style.fontWeight !== "normal") {
            if (global_const.tags_change_font_weight.indexOf(tag_name) !== -1) {
                current_clone_node.style.fontWeight = current_original_node_computed_style.fontWeight;
            }

            optimize_context._inside_font_weight_element = 1;
        }

        if (tag_name === "TABLE" && !optimize_context._inside_table_element) {
            optimize_context._inside_table_element = 1;
        }
    };

    UCReadability.prototype.removeReadabilityUnnecessaryAttributes = function (element) {
        if ( !element ) {
            return element;
        }

        var attributes = element.attributes;
        for (var i = 0; i < attributes.length; i++) {
            var attributeName = attributes[i].nodeName;
            if (global_const.readability_unnecessary_attributes_regex.test(attributeName)) {
                element.removeAttribute(attributeName);
                i--;
            }
        }

        return element;
    };

    //从所有标签 element 中筛选与 document.title / meta_title 相似度最高的element
    UCReadability.prototype.optimizeQualifiedArticleTitleElementBySimilarity = function (allHeaders, meta_title) {
        var document_title = this._contentDocument.title;
        var maxSimilarity = 0, resultHeaders = [], metaResultHeaders = [];

        for (var i = 0; i < allHeaders.length; ++i) {
            var headerElement = allHeaders[i];
            var text = utils.innerTextOrTextContentOfElement(headerElement);
            var similarity = utils.stringSimilarity(document_title, text);

            if (meta_title) {
                var meta_similarity = utils.stringSimilarity(meta_title, text);
                similarity += meta_similarity;
                meta_similarity > global_const.similarity_min_value && metaResultHeaders.push(headerElement);
            }

            if (similarity > maxSimilarity) {
                maxSimilarity = similarity;
                resultHeaders = [headerElement];
            }
            else if (similarity === maxSimilarity) {
                resultHeaders.push(headerElement);
            }
        }

        return [resultHeaders, metaResultHeaders];
    };

    UCReadability.prototype.findHighestScoreArticleTitleElement = function (allHeaders, resultHeaders,metaResultHeaders) {

        var articleRect = utils.boundingRectOfElement(this.findTopQualifiedArticleElement());

        // var articleWidth = articleRect.width;
        var articleCenterX = articleRect.left + articleRect.width / 2;
        var articleTopY = articleRect.top , articleAdjustedTopY = articleTopY;

        var bestHeader = null;
        for (var i = 0; i < allHeaders.length; i++) {
            var headerElement = allHeaders[i];
            var headerText = utils.innerTextOrTextContentOfElement(headerElement);
            if (!utils.isElementVisible(headerElement))
                continue;

            if (this.isElementHasUniqueDC_Title(headerElement)) {
                bestHeader = headerElement, bestHeader.headerText = headerText;
                break;
            }

            if (global_const.class_name_filter_regex.test(headerElement.className))
                continue;

            var headerRect = utils.boundingRectOfElement(headerElement),
                headerCenterX = headerRect.left + headerRect.width / 2,
                headerCenterY = headerRect.top + headerRect.height / 2,
                deltaX = headerCenterX - articleCenterX,
                deltaY = headerCenterY - articleAdjustedTopY,
                distance = Math.sqrt(deltaX * deltaX + deltaY * deltaY),
                headerScore;

            var isSuitable = this.isHeaderElementSuitable(headerElement, metaResultHeaders);

            if (!isSuitable) {
                if (distance > global_const.title_max_distance)
                    continue;
                if (headerCenterX < articleRect.left || headerCenterX > articleRect.right)
                    continue;

                headerScore =  Math.max(global_const.title_max_distance - distance, 0);
            }
            else {
                headerScore = global_const.title_max_distance;
            }

            var document_title = this._contentDocument.title;
            if (document_title && utils.stringsAreNearlyIdentical(headerText, document_title))
                headerScore *= 3;
            else if (utils.isPrefixOrSuffix(headerText,document_title))
                headerScore *= global_const.title_regex_mul;
            else if (headerText.length < global_const.title_min_text_length)
                continue;

            var ut = !1;
            var loc = this._contentDocument.location;
            var aElement = utils.firstAncestorElementWithTagName(headerElement, "A");  ///< 找到最近的tag为A的parrentElement
            aElement || (aElement = headerElement.querySelector("a"));
            if (aElement) {
                var ft = aElement.host === loc.host,
                    lt = aElement.pathname === loc.pathname;
                if (ft && lt)
                    headerScore *= global_const.title_regex_mul;
                else {
                    if (ft && utils.firstAncestorElementWithTagName(headerElement, "LI"))
                        continue;
                    headerScore *= .6, ut = !0;
                }
            }

            var headerFontSize = utils.computedFontSize(getComputedStyle(headerElement), 0);
            if (ut || (headerScore *= headerFontSize / global_const.default_font_size))
                headerScore *= 1 + .1 * utils.elementDepth(headerElement);

            var ht = parseInt(this.contentTextStyle().fontSize, 10);

            if(parseInt(headerFontSize, 10) > ht * global_const.title_font_size_mul)
                headerScore *= global_const.title_font_size_mul;

            var headerRegEx = global_const.title_extra_scope_regex;
            if (headerRegEx.test(headerElement.className) || headerRegEx.test(headerElement.getAttribute("id")))
                headerScore *= 1.5;
            var parentElement = headerElement.parentElement;

            if (parentElement && (headerRegEx.test(parentElement.className) || headerRegEx.test(parentElement.getAttribute("id")))) {
                headerScore *= 1.5;
            }

            if (resultHeaders.indexOf(headerElement) !== -1)
                headerScore *= 1.8;

            if (!bestHeader || headerScore > bestHeader.headerScore) {
                bestHeader = headerElement;
                bestHeader.headerScore = headerScore;
                bestHeader.headerText = headerText;
            }
        }

        return bestHeader;
    };

    UCReadability.prototype.makeFloatElementReadability = function (current_original_node, current_clone_node, original_article_node, clone_article_node, current_original_node_computed_style, optimize_context) {
        if ( !optimize_context || !current_original_node || !current_clone_node || !original_article_node || !clone_article_node) {
            return ;
        }

        if (optimize_context._inside_float_element === 1) {
            var current_original_node_bounds = utils.boundingRectOfElement(current_original_node);
            var original_article_node_bounds = utils.boundingRectOfElement(original_article_node);
            if (current_original_node_bounds.width === original_article_node_bounds.width) {
                current_clone_node.setAttribute("class", "float full-width");
            } else  {
                current_clone_node.setAttribute("class", "float " + current_original_node_computed_style["float"]);
            }
        }

        //从原对应的元素上，计算width属性，并设置到clone元素上
        var width_property = current_original_node.style.getPropertyValue("width");
        if (width_property) {
            current_clone_node.style.width = width_property;
        } else {

            var default_view = current_original_node.ownerDocument.defaultView;
            if (default_view) {
                try {
                     var rules = default_view.getMatchedCSSRules(current_original_node, ""); //通过获取应该到该节点的css-rule, 获取css样式设置
                     if (rules) {
                         for (var i = rules.length - 1; i >= 0; i--) {
                              width_property = rules[i].style.getPropertyValue("width");
                              if (width_property) {
                                  current_clone_node.style.width = width_property;
                                  break;
                              }
                         }
                     }
                } catch (err) {
            	     utils.log("getMatchedCSSRules err");
                }
            }
        }

        if (optimize_context._inside_float_element === 1 && !width_property) {
            current_clone_node.style.width = utils.boundingRectOfElement(current_original_node).width + "px";
        }

        var large_element_margin = current_clone_node.parentNode === clone_article_node ? 36 : 12;
        var cloned_width_value = current_clone_node.style.width;

        if (cloned_width_value && parseInt(cloned_width_value, 10) >= screen.width - large_element_margin) {
            current_clone_node.setAttribute("class", "large-element");
        }
    };

    UCReadability.prototype.makeImageElementReadability = function (current_original_node, current_clone_node, original_article_node, clone_article_node, current_original_node_computed_style, optimize_context) {
        if ( !optimize_context || !current_original_node || !current_clone_node || !original_article_node || !clone_article_node) {
            return ;
        }

        var image_unnecessary_attributes_count = global_const.readability_unnecessary_image_attributes.length;
        for (var i=0; i<image_unnecessary_attributes_count; i++) {
            current_clone_node.removeAttribute(global_const.readability_unnecessary_image_attributes[i]);
        }

        var image_attributes = current_clone_node.attributes;
        for (var i=0; i<image_attributes.length; i++) {

            var node_name = image_attributes[i].nodeName;
            if (!node_name) {
                continue ;
            }

            if (global_const.known_lazy_image_loading_attributes.indexOf(node_name.toLowerCase()) !== -1) {
                current_clone_node.setAttribute('src', current_clone_node.getAttribute(node_name));
                break ;
            }
        }

        if (!optimize_context._inside_float_element) { //对于非float元素
            var current_original_node_bounds = utils.boundingRectOfElement(current_original_node);

            //小尺寸图片
            if (current_original_node_bounds.width < global_const.readability_small_image_size_threshold
                && current_original_node_bounds.height < global_const.readability_small_image_size_threshold)
            {
                current_clone_node.setAttribute("class", "image-size-small");
            } else {
                var original_article_node_bounds = utils.boundingRectOfElement(original_article_node);
                if (current_original_node_bounds.width / original_article_node_bounds.width > global_const.readability_large_image_width_factor) {
                    current_clone_node.setAttribute("class", "image-size-large");
                }
            }

        } else {
            current_clone_node.style.float = current_original_node_computed_style.float;
        }
    };

    UCReadability.prototype.makeFontElementReadability = function (current_original_node, current_clone_node, original_article_node, clone_article_node, current_original_node_computed_style, optimize_context) {
        if ( !optimize_context || !current_original_node || !current_clone_node || !original_article_node || !clone_article_node) {
            return ;
        }

        var font_unnecessary_attributes_count = global_const.readability_unnecessary_font_attributes.length;
        for (var i=0; i<font_unnecessary_attributes_count; i++) {
            current_clone_node.removeAttribute(global_const.readability_unnecessary_font_attributes[i]);
        }
    };

    UCReadability.prototype.makeAElementReadability = function (current_original_node, current_clone_node, original_article_node, clone_article_node, current_original_node_computed_style, optimize_context) {
        if ( !optimize_context || !current_original_node || !current_clone_node || !original_article_node || !clone_article_node) {
            return current_clone_node;
        }

        if ( !current_clone_node.parentNode ) {
            return current_clone_node;
        }

        var replacement_node = this._contentDocument.createElement("span");
        if (current_clone_node.childElementCount === 1 && current_clone_node.firstElementChild.tagName === "IMG") {
            var imageElement = current_clone_node.firstElementChild;
            if (imageElement.width > global_const.readability_a_image_min_width && imageElement.height > global_const.readability_a_image_min_height) {
                replacement_node.setAttribute("class", "image-placeholder-class");
            }
        }

        if (!replacement_node.className) {
            replacement_node.setAttribute("class", "no-original-class-placeholder");
        }

        var readability_a_element = utils.replaceElement(current_clone_node, replacement_node);

        utils.log("make a element readability " + utils.nodeDescription(readability_a_element));

        return readability_a_element;

    };

    UCReadability.prototype.shouldRemoveElement = function (element, originalElement) {
        if (!element || !element.parentElement) {
            return false;
        }

        const MaxInputToParagraphRatio = 0.33;
        const MaxPositiveWeightLinkDensity = 0.5;
        const MaxStandardLinkDensity = 0.2;
        const MinimumTextLength = 25;
        const MinimumAverageImageArea = 200 * 200;

        var should_remove_element = true;
        do {

            //如果element内部不包含文本，则删除
            if (element.tagName !== "OBJECT" && element.tagName !== "EMBED" && element.tagName !== "CANVAS") {
                var hasElementOrTextNodeChild = false;
                for (var i = 0; i < element.childNodes.length; i++) {
                    var node = element.childNodes[i];
                    var nodeType = node.nodeType;
                    if (nodeType === Node.ELEMENT_NODE || (nodeType === Node.TEXT_NODE && !utils.isEmptyTextNode(node))) {
                        hasElementOrTextNodeChild = true;
                        break;
                    }
                }

                if (!hasElementOrTextNodeChild) {
                    utils.log("should prune object with no text" + utils.nodeDescription(element));
                    break;
                }
            }

            //"CANVAS" 保留
            if (element.tagName === "CANVAS") {
                should_remove_element = false;
                break;
            }

            //权重过小，删除
            var classIdWeight = 0;
            if (originalElement) {
                if (global_const.readability_positive_regex.test(originalElement.className)) classIdWeight++;
                if (global_const.readability_positive_regex.test(originalElement.id)) classIdWeight++;
                if (global_const.readability_negative_regex.test(originalElement.className)) classIdWeight--;
                if (global_const.readability_negative_regex.test(originalElement.id)) classIdWeight--;
            }
            if (classIdWeight < 0) {
                utils.log("should prune element with id attribute " + utils.nodeDescription(element));
                break;
            }

            //UL元素，如果内部包含iframe和script，则删除
            if (element.tagName === "UL") {
                if (!originalElement.querySelector("iframe") || !originalElement.querySelector("script"))
                {
                    should_remove_element = false;
                }

                break;
            }

            //OBJECT元素，如果不是特定站点的sr或data, 则删除
            if (element.tagName === "OBJECT") {
                const PlugInsToKeepRegEx = /youtube|vimeo|dailymotion/;
                var embedElement = element.querySelector("embed[src]");
                if (embedElement && PlugInsToKeepRegEx.test(embedElement.src)) {
                    should_remove_element = false;
                    break;
                }

                var dataAttribute = element.getAttribute("data");
                if (dataAttribute && PlugInsToKeepRegEx.test(dataAttribute)) {
                    should_remove_element = false;
                    break;
                }

                break;
            }

            //对只有一个子元素的节点，如果是A标签，则保留
            if (element.childElementCount === 1) {
                var childElement = element.firstElementChild;

                if (childElement.tagName === "A") {
                    should_remove_element = false;
                    break;
                }

                //这里应该是针对特定站点的适配
                if (childElement.tagName === "SPAN" && childElement.className === "no-original-class-placeholder" && utils.isElementDescendantOf(childElement, "TABLE")) {
                    should_remove_element = false;
                    break;
                }
            }

            //如果内部所有图片元素加起来页面超过某个阈值，则不需要删除
            var imageElements = element.querySelectorAll("img");
            var imageElementCount = imageElements.length;
            if (imageElementCount) {
                var averageImageArea = 0;
                for (var i = 0; i < imageElementCount; i++) {
                    var originalImage = imageElements[i].original_node;
                    if (!utils.isElementVisible(originalImage)) continue;
                    var originalRect = utils.boundingRectOfElement(originalImage);
                    averageImageArea += (originalRect.width / imageElementCount) * (originalRect.height / imageElementCount);
                }
                if (averageImageArea > MinimumAverageImageArea){
                    should_remove_element = false;
                    break;
                }
            }

            if (!utils.statementsSegmentationLessThan(element, 10)) {
                should_remove_element = false;
                break;
            }

            //段落判断
            var p = element.querySelectorAll("p").length;
            var br = element.querySelectorAll("br").length;
            var numParagraphs = p + Math.floor(br / 2); //段落数为P, 两个br也看作一个段落分割
            if (imageElementCount > numParagraphs) { //图片数大于段落数
                utils.log("should remove element due to image count > p: " + utils.nodeDescription(element));
                break;
            }

            if (element.querySelectorAll("li").length > numParagraphs) {//li元素大于段落数
                utils.log("should remove element due to li count > p: " + utils.nodeDescription(element));
                break;
            }

            if (element.querySelectorAll("input").length / numParagraphs > MaxInputToParagraphRatio) {
                utils.log("should remove element due to input number > p: " + utils.nodeDescription(element));
                break;
            }

            if (element.textContent.length < MinimumTextLength && (imageElementCount !== 1) && element.tagName !== 'P') {
                utils.log("should remove element due text length < 25" + utils.nodeDescription(element));
                break;
            }

            //如果同embed元素，删除
            if (element.querySelector("embed"))
            {
                utils.log("should remove embed element: " + utils.nodeDescription(element));
                break;
            }

            //A标签内容密度
            var linkDensity = utils.calculateLinkDensity(element);
            if (classIdWeight >= 1 && linkDensity > MaxPositiveWeightLinkDensity){

                utils.log("should remove element due to class id >1: " + utils.nodeDescription(element));
                break;
            }
            if (classIdWeight < 1 && linkDensity > MaxStandardLinkDensity){
                utils.log("should remove element due to class id < 1: " + utils.nodeDescription(element));
                break;
            }

            //Table元素判断，内部文本过少，删除
            if (element.tagName === "TABLE") {
                var textLength = utils.stripAllWhitespace(element.innerText).length;
                var originalTextLength = utils.stripAllWhitespace(originalElement.innerText).length;
                if (textLength <= (originalTextLength * 0.5)) {
                    utils.log("should remove table element due to text length: " + utils.nodeDescription(element));
                    break;
                }
            }

            should_remove_element = false;
        } while (0);


        return should_remove_element;
    };

    //候选节点修剪
    UCReadability.prototype.optimizeArticleNode = function (original_article_node, clone_article_node, allowed_return_null) {
        utils.log("###############################################################################");
        if (!original_article_node || !clone_article_node) {
            utils.log("invalid params for optimize article node");
        }

        utils.log("optimize article node with original " + utils.nodeDescription(original_article_node) + "; clone node: " + utils.nodeDescription(clone_article_node));
        var current_original_node = original_article_node;
        var current_clone_node = clone_article_node;
        current_clone_node.original_node = current_original_node;

        var elements_should_check_for_delete = [];

        var optimize_context = new UCArticleNodeOptimizeContext();
        while (current_original_node) {
            var element_should_delete = null;

            utils.log("will process node original:" + utils.nodeDescription(current_original_node) + ';  clone :' + utils.nodeDescription(current_clone_node));

            do {
                if (!utils.isReadabilityTagName(current_clone_node.tagName)) {
                    utils.log("not a readability tag , should delete " + utils.nodeDescription(current_original_node));
                    element_should_delete = current_clone_node;
                    break;
                }

                var current_element_offset = current_original_node.offsetTop - original_article_node.offsetTop;
                if (this.isElementRedundantWithTitleElement(current_original_node, current_clone_node, current_element_offset)) {
                    utils.log("same with title element , should delete " + utils.nodeDescription(current_original_node));
                    element_should_delete = current_clone_node;
                    break;
                }

                var computed_style = getComputedStyle(current_original_node);
                if (computed_style.display === "none") {
                    utils.log("not a visible tag , should delete " + utils.nodeDescription(current_original_node));
                    element_should_delete = current_clone_node;
                    break;
                }

                current_clone_node = this.wrapBlockTextIntoParagraph(current_original_node, current_clone_node, computed_style, optimize_context);
                current_clone_node.original_node = current_original_node;

                current_clone_node = this.removeReadabilityUnnecessaryAttributes(current_clone_node);
                current_clone_node.original_node = current_original_node;

                this.updateNodeOptimizeContext(current_original_node, current_clone_node, original_article_node, clone_article_node,  computed_style, optimize_context);


                if (optimize_context._inside_float_element) {
                    this.makeFloatElementReadability(current_original_node, current_clone_node, original_article_node, clone_article_node,computed_style, optimize_context);
                }

                var current_clone_node_tags_name = current_clone_node.tagName;
                utils.log("current_clone_node_tags_name:" + current_clone_node_tags_name);
                if (current_clone_node_tags_name === "IMG") {
                    this.makeImageElementReadability(current_original_node, current_clone_node, original_article_node, clone_article_node,computed_style, optimize_context);
                } else if (current_clone_node_tags_name === "FONT") {
                    this.makeFontElementReadability(current_original_node, current_clone_node, original_article_node, clone_article_node,computed_style, optimize_context);
                } else if (current_clone_node_tags_name === "A" && current_clone_node.parentNode) {

                    if (utils.isNonStandardLink(current_clone_node.getAttribute("href"))) {

                        if ( !optimize_context._inside_table_element && !current_clone_node.childElementCount && current_clone_node.parentElement.childElementCount === 1) {
                            var x_path_result = this._contentDocument.evaluate("text()", current_clone_node.parentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
                            if (!x_path_result.snapshotLength){ //如果有text兄弟节点
                                element_should_delete = current_clone_node;
                                break;
                            }

                            current_clone_node = this.makeAElementReadability(current_original_node, current_clone_node, original_article_node, clone_article_node,computed_style, optimize_context);
                        }
                    }
                }

                if ( current_clone_node.parentNode && global_const.readability_suspend_tags.indexOf(current_clone_node_tags_name) !== -1) {
                    elements_should_check_for_delete.push(current_clone_node);
                }

            } while (0); // do {} while(0)

            var firstElementChild = element_should_delete ? null : current_original_node.firstElementChild;
            utils.log('next element select: {element_should_delete :' + utils.nodeDescription(element_should_delete) + ', original:'  + utils.nodeDescription(current_original_node) + ', first_child:' + utils.nodeDescription(current_original_node.firstElementChild) + ']');
            if (firstElementChild && current_clone_node.firstElementChild != null) {
                current_original_node = firstElementChild;
                current_clone_node = current_clone_node.firstElementChild;
                current_clone_node.original_node = current_original_node;
                optimize_context.moveContextWithLevelDelt(1);
                utils.log("move next node to first child " + utils.nodeDescription(current_original_node));
            } else {
                var nextElementSibling;
                while (current_original_node !== original_article_node && !(nextElementSibling = current_original_node.nextElementSibling)) {
                    current_original_node = current_original_node.parentElement;
                    current_clone_node = current_clone_node.parentElement;
                    if (current_clone_node != null) {
                       current_clone_node.original_node = current_original_node;
                       optimize_context.moveContextWithLevelDelt(-1);
                       utils.log("move next node to sibling " + utils.nodeDescription(current_original_node));
                    } else {
                        break; //如果没有父节点，那么会出现异常，跳出循环
                    }
                }

                if (current_original_node === original_article_node) {
                    if (element_should_delete) {
                        if (element_should_delete.parentElement) {
                            element_should_delete.parentElement.removeChild(element_should_delete);
                        }
                        else if (allowed_return_null) {
                            return null;
                        }
                    }
                    break;
                }
                current_original_node = nextElementSibling;
                utils.log('next process final set to :' + utils.nodeDescription(current_original_node));
                current_clone_node = current_clone_node.nextElementSibling;
                current_clone_node.original_node = current_original_node;
                optimize_context.moveContextToSibling();
            }

            if (element_should_delete) {
                if (element_should_delete.parentElement) {
                    element_should_delete.parentElement.removeChild(element_should_delete);
                } else if (allowed_return_null) {
                    return null;
                }
            }
        }//while


        utils.log("element should check for delete count is " + elements_should_check_for_delete.length);
        for (var i = elements_should_check_for_delete.length - 1; i >= 0; i--) {
            var element = elements_should_check_for_delete[i];
            if (element.parentNode && this.shouldRemoveElement(element, element.original_node)) {
                utils.log('will remove element: ' + utils.nodeDescription(element));
                element.parentNode.removeChild(element);
            }
        }

        if (allowed_return_null && current_clone_node) {
            var node_text = current_clone_node.innerText;
            var no_white_space_text = utils.stripAllWhitespace(node_text);

            if (!no_white_space_text.length) {
                return null;
            }
        }

        utils.log("###############################################################################");
        return current_clone_node;
    };


    UCReadability.prototype.removeAllUnnecessaryFloatElements = function (floatElements) {
        if ( !floatElements ) {
            return ;
        }

        for (var i = 0; i < floatElements.length; i++) {
            var pruneFloatedElement = false;
            var floatElement = floatElements[i];
            if (!pruneFloatedElement) {
                var anchors = floatElement.querySelectorAll("a, span.image-placeholder-class");
                var replacedAnchors = floatElement.querySelectorAll("span.no-original-class-placeholder");
                pruneFloatedElement = floatElement.parentNode && replacedAnchors.length > anchors.length;
            }
            if (!pruneFloatedElement) {
                var plugInsInClonedElement = floatElement.querySelectorAll("embed, object").length;
                var plugInsInOriginalElement = floatElement.original_node.querySelectorAll("embed, object").length;
                if (!plugInsInClonedElement && plugInsInOriginalElement) pruneFloatedElement = true;
            }
            if (!pruneFloatedElement) {
                var imagesInOriginalElement = floatElement.original_node.querySelectorAll("img");
                var visibleImagesInOriginalElementCount = 0;
                for (var j = 0; j < imagesInOriginalElement.length; j++) {
                    if (utils.isElementVisible(imagesInOriginalElement[j])) visibleImagesInOriginalElementCount++;
                    if (visibleImagesInOriginalElementCount > 1) break;
                }
                if (visibleImagesInOriginalElementCount === 1) {
                    var imagesInClonedElementCount = floatElement.querySelectorAll("img").length;
                    if (!imagesInClonedElementCount) pruneFloatedElement = true;
                }
            }
            if (pruneFloatedElement) {
                floatElement.parentNode.removeChild(floatElement);
            }
        }
    };

    UCReadability.prototype.isReadability = function () { //isReaderModeAvailable
        this._topQualifiedArticleElement = this.findTopQualifiedArticleElement();

        return !!this._topQualifiedArticleElement;
    };

    UCReadability.prototype.optimizedArticleElement = function () { //adoptableArticle
        if (this._readabilityArticleElement) {

            utils.log("get optimized article element with cache copy...");
            return this._readabilityArticleElement.cloneNode(true); //deep Optional true if the children of the node should also be cloned, or false to clone only the specified node.
        }


        var topQualifiedArticleElement = this.topQualifiedArticleElement();
        this._readabilityArticleElement = topQualifiedArticleElement ? topQualifiedArticleElement.cloneNode(true) : null;

        if (!this._readabilityArticleElement) {
            return null;
        }

        var that = this;
        if (this._readabilityArticleElement.childNodes.length < 1){
            this._readabilityArticleElement = document.createElement("div");
            var originalNodeChildNodes = topQualifiedArticleElement.childNodes;
            originalNodeChildNodes.forEach(function(node){
                that._readabilityArticleElement.appendChild(node.cloneNode(true));
            });
        }

        this._readabilityArticleElement = this.optimizeArticleNode(topQualifiedArticleElement, this._readabilityArticleElement, false);
        this._readabilityArticleElement = utils.wrapElementInBlock(this._readabilityArticleElement);

        this.removeAllUnnecessaryFloatElements(this._readabilityArticleElement.querySelectorAll(".float"));

        return this._readabilityArticleElement.cloneNode(true);
    };


    //////////////////Interface/////////////////////////////
    //获取title
    UCReadability.prototype.readabilityTitle = function () {
        return this.findQualifiedArticleNodeTitle();
    };

    //经过拼接的HTML节点
    UCReadability.prototype.readabilityData = function () { //outerArticle

        var contentElement = this.optimizedArticleElement();
        var readabilityData = this.createPageNode(contentElement, true);
        var pageNode = readabilityData["pageNode"];
        readabilityData["pageNodeHTML"] = encodeURIComponent(pageNode.outerHTML);
        delete readabilityData["pageNode"];

        return JSON.stringify(readabilityData);
    };

    UCReadability.prototype.getAllText = function (options = {returnAsArray: true }) {
        var paragraphArray = this.getParagraphArray(document.body);
        var readabilityData = {};
        if (paragraphArray.length > 0) {
            readabilityData["paragraphArray"] = encodeURIComponent(JSON.stringify(paragraphArray));
        }

        return readabilityData;

    };

    UCReadability.prototype.reExtractReadabilityData = function(){
        this._readabilityArticleElement = null;
        this._hasRunReadabilityDetect = false;
        this._topQualifiedArticle = null;
    }

    UCReadability.prototype.createPageNode = function (contentNode, isFirstPageNode) {
        var pageNode = document.createElement("div");
        pageNode.className = "page";
        if (isFirstPageNode)
        {
            pageNode.setAttribute("style", "font-size:17px;line-height:27px;");
        }
        else
        {
            var currentPageNodes = document.getElementsByClassName("page");
            if (currentPageNodes.length > 0)
            {
                var firstPageNode = currentPageNodes[0];
                pageNode.style.fontSize = firstPageNode.style.fontSize;
                pageNode.style.lineHeight = firstPageNode.style.lineHeight;
            }
        }

        if (!this.isReadDirectionLTR()) {
            utils.addElementClass(pageNode, "rtl");
        }

        var pageNumberNode = document.createElement("div");
        pageNumberNode.className = "page-number";
        pageNode.appendChild(pageNumberNode);

        if (isFirstPageNode)
        {
            var titleNode = document.createElement("h1");
            titleNode.className = "title";
            titleNode.textContent = this.readabilityTitle();
            pageNode.appendChild(titleNode);
        }

        var paragraphArray = this.getParagraphArray(contentNode);

        while (contentNode.firstChild)
        {
            pageNode.appendChild(contentNode.firstChild);
        }

        var readabilityData = {};

        if (paragraphArray.length > 0){
            readabilityData["paragraphArray"] = encodeURIComponent(JSON.stringify(paragraphArray));
        }

        readabilityData["pageNode"] = pageNode;
        return readabilityData;
    };

    UCReadability.prototype.getParagraphArray = function (contentNode) {
        var textNodeStartId = parseInt(new Date().getTime() / 1000, 10);
        var paragraphArray = [];
        var allTextNodeArray = utils.extractDomContent(contentNode, { returnAsArray: true });
        allTextNodeArray.forEach(function (textNode) {
            utils.log("textNode:" + textNode);
            var textContent = textNode.trim();
            if (textContent.length > 0) {
                //每段超过字符数后自动分割
                if (textContent.length > global_const.tts_paragraph_max_length) {
                    var splitContent = textContent.split("。");
                    if (splitContent) {
                        var newParagraph = '';
                        var newParagraphLength = 0;
                        for (let index = 0; index < splitContent.length; index++) {
                            const element = splitContent[index];
                            if (newParagraphLength < global_const.tts_paragraph_max_length && index != splitContent.length -1 ) {
                                newParagraphLength = element.length + newParagraphLength;
                                newParagraph = newParagraph + element + "。";
                            } else {
                                var paragraphDict = {};
                                if (index != splitContent.length - 1) {
                                    newParagraph = newParagraph + element + "。";
                                } else {
                                    newParagraph = newParagraph + element;
                                }
                                paragraphDict[textNodeStartId] = newParagraph;
                                paragraphArray.push(paragraphDict);
                                textNodeStartId = textNodeStartId + 1;

                                utils.log("paragraph:" + newParagraph);
                                newParagraph = '';
                                newParagraphLength = 0;
                            }

                        }
                    }
                } else {
                    var paragraphDict = {};
                    paragraphDict[textNodeStartId] = textContent;
                    paragraphArray.push(paragraphDict);
                    textNodeStartId = textNodeStartId + 1;
                    utils.log("paragraph:" + textContent);
                }
            }
        });
        return paragraphArray;
    };

    //判断是否可进入悦读
    UCReadability.prototype.detectedReadability = function () {
        var that = this;
        if(this._retryExtractDataTimes === undefined)
        {
            this._retryExtractDataTimes = 0;
        }
        setTimeout(function(){
            //console.info("extract times : " + that._retryExtractDataTimes);
            var isAvailable = that.isReadability();
            if (!isAvailable && that._retryExtractDataTimes < 3)
            {
                that._retryExtractDataTimes = that._retryExtractDataTimes + 1;
                that.reExtractReadabilityData();
                that.detectedReadability();
                return;
            }
            /**
            * 0: NOT available
            * 1: available
            */
            var ret = (isAvailable ? 1 : 0);
            UCBrowserMessageCenter.sendMessage('reader_check_' + ret);
        }, 1500 * (this._retryExtractDataTimes + 1));
    };

    //当前页面的标题
    UCReadability.prototype.currentPageTitle = function () {
        return this._contentDocument.title;
    };

   //获取最合适的候选节点
   UCReadability.prototype.topQualifiedArticleElement = function () {
        return this.findTopQualifiedArticleElement();
   };

    context.UCReadabilityContext = new UCReadability(document);
    context.UCReadability = UCReadability;

})(window);