precision highp float;

attribute vec4 aVertexCo;
attribute vec2 aTextureCo;
attribute vec3 aNormal;

uniform mat4 WorldViewProj;
uniform mat4 WorldView;
uniform mat4 View;
uniform vec3 SunDir;

varying vec2 vTexcoord0;
varying vec3 vNormal;
varying vec3 vView;
varying vec3 vLightDir;

void main()
{
	vNormal = (WorldView * vec4(aNormal.xyz, 0.0)).xyz;
    vLightDir = (View * vec4(SunDir, 0.0)).xyz;
    vView = -(WorldView * vec4(aVertexCo.xyz, 1.0)).xyz;
    vTexcoord0 = aTextureCo;
	gl_Position = WorldViewProj * aVertexCo;
}

/*
{ // 参数会根据ps情况自动优化
    
#if defined(DIFFUSE_ENABLE) || defined(SPECULAR_ENABLE)
	vNormal = (WorldView * vec4(aNormal.xyz, 0.0)).xyz;
    vLightDir = (View * vec4(SunDir, 0.0)).xyz;
#endif

#ifdef SPECULAR_ENABLE
    vView = -(WorldView * vec4(aVertexCo.xyz, 1.0)).xyz;
#endif

#if defined(DIFFUSE_ENABLE) || defined(AMBIENT_ENABLE)
    vTexcoord0 = aTextureCo;
#endif

	gl_Position = WorldViewProj * aVertexCo;
}
*/
