
attribute vec4 aVertexCo;
attribute vec2 aTextureCo;

uniform vec2 TexSize0;
uniform vec2 TexSize1;
uniform float  BloomDownScale;
uniform vec2 BloomUpScales;

varying mediump vec4 TexCoord0;
varying mediump vec4 TexCoord1;
varying mediump vec4 TexCoord2;
varying mediump vec4 TexCoord3;
varying mediump vec4 TexCoord4;
varying mediump vec4 TexCoord5;
varying mediump vec4 TexCoord6;
varying mediump vec4 TexCoord7;

vec2 Circle(float Start, float Points, float Point) 
{
	float Rad = (3.141592 * 2.0 * (1.0 / Points)) * (Point + Start);
	return vec2(sin(Rad), cos(Rad));
}



void main()
{
	gl_Position = aVertexCo;

	float Start = 2.0/7.0;
	float Scale = BloomDownScale;
	vec2 tex = aTextureCo;
	TexCoord0.xy = tex.xy;
	TexCoord0.zw = tex.xy + Circle(Start, 7.0, 0.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord1.xy = tex.xy + Circle(Start, 7.0, 1.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord1.zw = tex.xy + Circle(Start, 7.0, 2.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord2.xy = tex.xy + Circle(Start, 7.0, 3.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord2.zw = tex.xy + Circle(Start, 7.0, 4.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord3.xy = tex.xy + Circle(Start, 7.0, 5.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord3.zw = tex.xy + Circle(Start, 7.0, 6.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord4 = vec4(0.0, 0.0, 0.0, 0.0);
	TexCoord5 = vec4(0.0, 0.0, 0.0, 0.0);
	TexCoord6 = vec4(0.0, 0.0, 0.0, 0.0);
	TexCoord7 = vec4(0.0, 0.0, 0.0, 0.0);
}



