
attribute vec4 aVertexCo;
attribute vec2 aTextureCo;

uniform vec2 TexSize0;
uniform vec2 TexSize1;
uniform float  BloomDownScale;
uniform vec2 BloomUpScales;

varying mediump vec4 TexCoord0;
varying mediump vec4 TexCoord1;
varying mediump vec4 TexCoord2;
varying mediump vec4 TexCoord3;
varying mediump vec4 TexCoord4;
varying mediump vec4 TexCoord5;
varying mediump vec4 TexCoord6;
varying mediump vec4 TexCoord7;

vec2 Circle(float Start, float Points, float Point) 
{
	float Rad = (3.141592 * 2.0 * (1.0 / Points)) * (Point + Start);
	return vec2(sin(Rad), cos(Rad));
}

void main()
{
	gl_Position = aVertexCo;

	float Start;
	float Scale;

	Start = 2.0/7.0;
	Scale = BloomUpScales.x;
	vec2 tex = aTextureCo;
	TexCoord0.xy = tex.xy + Circle(Start, 7.0, 0.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord0.zw = tex.xy + Circle(Start, 7.0, 1.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord1.xy = tex.xy + Circle(Start, 7.0, 2.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord1.zw = tex.xy + Circle(Start, 7.0, 3.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord2.xy = tex.xy + Circle(Start, 7.0, 4.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord2.zw = tex.xy + Circle(Start, 7.0, 5.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );
	TexCoord3.xy = tex.xy + Circle(Start, 7.0, 6.0) * Scale * vec2( 1.0 / TexSize0.x,  1.0 / TexSize0.y );

	TexCoord3.zw = tex.xy;

	Start = 2.0/7.0;
	Scale = BloomUpScales.y;
	tex = aTextureCo;
	TexCoord4.xy = tex.xy + Circle(Start, 7.0, 0.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord4.zw = tex.xy + Circle(Start, 7.0, 1.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord5.xy = tex.xy + Circle(Start, 7.0, 2.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord5.zw = tex.xy + Circle(Start, 7.0, 3.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord6.xy = tex.xy + Circle(Start, 7.0, 4.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord6.zw = tex.xy + Circle(Start, 7.0, 5.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord7.xy = tex.xy + Circle(Start, 7.0, 6.0) * Scale * vec2( 1.0 / TexSize1.x,  1.0 / TexSize1.y );
	TexCoord7.zw = vec2(0.0, 0.0);
}



