precision highp float;
varying vec2 vTextureCo;

uniform vec2 uStep;
//mask
uniform sampler2D uTexture;

vec4 r(float x,float y){
    return texture2D(uTexture ,vTextureCo+vec2(x*uStep.x,y*uStep.y));
}

vec4 gauss(){
    vec4 color = r(0.0,0.0);

    color += r(-2.0,-2.0);
    color += r(-2.0,-1.0);
    color += r(-2.0,0.0);
    color += r(-2.0,1.0);
    color += r(-2.0,2.0);
    color += r(-1.0,-2.0);
    color += r(-1.0,2.0);
    color += r(0.0,-2.0);
    color += r(0.0,2.0);
    color += r(1.0,-2.0);
    color += r(1.0,2.0);
    color += r(2.0,-2.0);
    color += r(2.0,-1.0);
    color += r(2.0,0.0);
    color += r(2.0,1.0);
    color += r(2.0,2.0);

    color += r(-1.0,-1.0);
    color += r(-1.0,0.0);
    color += r(-1.0,1.0);
    color += r(0.0,-1.0);
    color += r(0.0,1.0);
    color += r(1.0,-1.0);
    color += r(1.0,0.0);
    color += r(1.0,1.0);
    return color;
}

void main() {
    gl_FragColor = gauss()/25.0;
}
