attribute vec4 aVertexCo;
attribute vec2 aTextureCo;
attribute vec3 aNormal;
attribute vec3 aVertexTangent;


varying	vec2 uv;
varying	vec3 normalWorld;
varying	vec3 tangentWorld;
varying	vec3 binormalWorld;
varying	vec3 posWorld;

uniform mat4 WorldViewProj;
uniform mat4 World;

void main()
{
    gl_Position = WorldViewProj * vec4( aVertexCo.xyz, 1.0 );
	normalWorld = (World * vec4( aNormal, 0.0 )).xyz;
	posWorld =  ( World * vec4( aVertexCo.xyz, 1.0 ) ).xyz;
	tangentWorld = ( World * vec4( aVertexTangent.rgb, 0.0 )).xyz;
	binormalWorld = cross(normalWorld.xyz, tangentWorld.xyz);
	tangentWorld = cross(binormalWorld.xyz, normalWorld.xyz);
    uv = aTextureCo;                                                  
}
