-- require "gesture_event"
local MiscUtil = require "utils/misc_util"

local BaseGestureDetector = {
    type = "base",
    gestureInProgress = false,
    prevEvent = nil,
    currEvent = nil,
    -- timeDelta = nil,

    listener = nil,

    fingerState = {},
}

function BaseGestureDetector:Create()
    return MiscUtil.DeepCopy(self)
end

function BaseGestureDetector.BaseGestureDetectorInherit(son)
    local o = MiscUtil.DeepCopy(son)
    local p = BaseGestureDetector:Create()
    setmetatable(o, p)
    p.__index = p
    return o
end

function BaseGestureDetector:OnTouch(gestureInputEvent)
    if self.gestureInProgress then
        self:HandleInProgressEvent(gestureInputEvent)
    else
        self:HandleStartProgressEvent(gestureInputEvent)
    end
end

-- virtual function
function BaseGestureDetector:Init(config)
    print("BaseGestureDetector:Init")
end

-- virtual function
function BaseGestureDetector:HandleStartProgressEvent(gestureInputEvent) 
    print("base HandleStartProgressEvent")
end

-- virtual function
function BaseGestureDetector:HandleInProgressEvent(gestureInputEvent) 
    print("base HandleInProgressEvent")
end

function BaseGestureDetector:UpdateStateByEvent(currEvent)
    self.prevEvent = self.currEvent
    self.currEvent = currEvent
    self.fingerState[currEvent.fingerId] = currEvent
    -- print("SwipeGestureDetector: fingerNum after update", MiscUtil.TableLength(self.fingerState))
end

function BaseGestureDetector:ResetState()
    self.gestureInProgress = false
    self.prevEvent = nil
    self.currEvent = nil
    self.fingerState = {}
    print("BaseGestureDetector: reset state")
end

function BaseGestureDetector:NotSingle()
    -- print("SwipeGestureDetector: fingerNum", MiscUtil.TableLength(self.fingerState))
    -- MiscUtil.PrintTable(self.fingerState)
    return not (MiscUtil.TableLength(self.fingerState) == 1)
end

function BaseGestureDetector:AllUp()
    for k, v in pairs(self.fingerState) do
        print("SwipeGestureDetector: finger id", v.fingerId, "state", v.state)
        if v.state ~= 2 and v.state ~= 3 then
            return false
        end
    end
    return true
end

return BaseGestureDetector

