-- local json = require "json"

local TapGestureDetector = require "touch_gesture_engine/gesture_detector/tap_gesture_detector"
local SwiptGestureDetector = require "touch_gesture_engine/gesture_detector/swipe_gesture_detector"
local PinchGestureDetector = require "touch_gesture_engine/gesture_detector/pinch_gesture_detector"

local GestureDetectorFactory = {}

function GestureDetectorFactory:GetDetector(name)
    if name == "tap" then
        return TapGestureDetector:Create()
    elseif name == "swipe" then
        return SwiptGestureDetector:Create()
    elseif name == "pinch" then
        return PinchGestureDetector:Create()
    else 
        print("invalid gesture detector name:", name)
        return nil
    end
end

return GestureDetectorFactory
