local BaseGestureDetector = require "touch_gesture_engine/gesture_detector/base_gesture_detector"

local function TableLen(t)
    local cnt = 0
    for i, v in pairs(t) do
        cnt = cnt + 1
    end
    return cnt
end

local TapGestureDetector = {
    fingerEvent = {}
}

function TapGestureDetector:Create()
    return BaseGestureDetector.BaseGestureDetectorInherit(self)
end

-- virtual function
local THRESHOLD_TAP_TIME = 0.2 * 1000
local THRESHOLD_TAP_DISTANCE = 0.1
function TapGestureDetector:Init(config, listener)
    self.listener = listener

    self.config = config
    self.threshold_time = THRESHOLD_TAP_TIME
    if self.config.max_time_interval then
        self.threshold_time = self.config.max_time_interval
    end

    self.threshold_distance = THRESHOLD_TAP_DISTANCE
    if self.config.threshold_distance then
        self.threshold_distance = self.config.threshold_distance
    end

    print("dTime", self.threshold_time, self.threshold_distance)

    print("TapGestureDetector:Init")
    return true
end

-- virtual function
-- state : down-0, move-1, up-2, cancle-3
function TapGestureDetector:HandleStartProgressEvent(gestureInputEvent) 
    print("TapGestureDetector HandleStartProgressEvent")
    local state = gestureInputEvent.state
    local time = gestureInputEvent.time
    local fingerId = gestureInputEvent.fingerId

    if state == 0 then
        self.fingerEvent[fingerId] = {gestureInputEvent, nil} -- {begin event, end event}
        print("TapGestureDetector: TapGestureDetector: get down")

    elseif state == 2 or state == 3 then
        local function TapMatch(prevEvent, currEvent)
            local dX = math.abs(currEvent.x - prevEvent.x)
            local dY = math.abs(currEvent.y - prevEvent.y)
            print("TapGestureDetector: dx, dy, dTime", dX, dY, currEvent.time - prevEvent.time)
            return currEvent.time - prevEvent.time < self.threshold_time  and dX < self.threshold_distance and dY < self.threshold_distance 
            -- return currEvent.time - prevEvent.time < THRESHOLD_TAP_TIME and math.sqrt(dX ^ 2 + dY ^ 2) < THRESHOLD_TAP_DISTANCE
        end
        self.fingerEvent[fingerId][2] = gestureInputEvent
        local fingerNum = TableLen(self.fingerEvent)
        if fingerNum ~= 1 then
            self.fingerEvent[fingerId] = nil
            print("TapGestureDetector: finger num ~= 1", fingerNum)
            return
        end

        local beginEvent, endEvent = self.fingerEvent[fingerId][1], self.fingerEvent[fingerId][2]
        if not beginEvent or not endEvent then
            self.fingerEvent[fingerId] = nil
            print("TapGestureDetector: ERROR, beginEvent or endEvent is nil", beginEvent, endEvent)
            return
        end  

        if TapMatch(beginEvent, endEvent) then
            local oe = {
                x = endEvent.x,
                y = endEvent.y
            }
            self.listener:OnTap(oe)
        end
        self.fingerEvent[fingerId] = nil

    elseif state == 1 then
        -- self:ResetState()
    end
end

-- virtual function
function TapGestureDetector:HandleInProgressEvent(gestureInputEvent) 
    print("TapGestureDetector: HandleInProgressEvent")
end

return TapGestureDetector

