package.root = "."
package.path = "./utils/?.lua;" .. package.path
package.path = "./touch_gesture_engine/?.lua;" .. package.path
package.path = "./touch_gesture_engine/gesture_detector/?.lua;" .. package.path

local MiscUtil = require "misc_util"
local TouchGestureEngine = require "touch_gesture_engine"

local listener = {}
listener.OnTap = function(oe)
    print("tap point:", oe.x, oe.y)
end

listener.OnSwipeBegin = function(oe)
    print("HCD: OnSwipeBegin")
    return true
end

listener.OnSwipeEnd = function(oe)
    print("HCD: OnSwipeEnd")
    return
end

listener.OnSwipe = function(oe)
    print("HCD: OnSwipe")
    print("delta x:", oe.deltaX, "delta y:", oe.deltaY)
end

TouchGestureEngine:Init("./touch_gesture_engine/touch_gesture_engine.conf", listener)
-- tap
-- TouchGestureEngine:OnTouch({time = 0, state = 0})
-- TouchGestureEngine:OnTouch({x = 11, y = 22, time = 0.1, state = 2})

--swipe
TouchGestureEngine:OnTouch({x = 0, y = 0, time = 0, state = 0})
TouchGestureEngine:OnTouch({x = 1, y = 1, time = 0, state = 1})
TouchGestureEngine:OnTouch({x = 2, y = 2, time = 0, state = 1})
TouchGestureEngine:OnTouch({x = 2, y = 2, time = 0, state = 2})