require("uiwidget")

local UIButton = UIWidget:new(nil)
UIButton.listeners = {}

function UIButton:new(engineObj, son)
    print("UIButton: in new")
    local o = UIWidget:new(engineObj)
    setmetatable(o, self)
    self.__index = self
    if engineObj then
        local widget = TypeCast(engineObj, "IUIWidget")
        local context = TypeCast(TypeCast(widget:GetParentWindow(), "CUIWindow"), "CResObj"):GetEngineContext()
        self.listener = context:GetEventSystem():CreateAndRegEventListenerTouchTap(self.OnTapCallback)
        self.listener:SetPriority(widget:GetListenerPriority())
        self.listeners[self.listener:GetAddress()] = {
            engineObj = TypeCast(engineObj, "CUIButton"),
            son = son
        }
    end
    print("UIButton: new success")
    return o
end

-- function UIButton:Inherit(engineObj, son)
--     print("===", engineObj, son)
--     local o = UIButton:new(engineObj, son)
--     setmetatable(o, son)
--     self.__index = son
--     return o
-- end

function UIButton.OnTapCallback(event, listener)
    local x, y = event:GetScreenX(), event:GetScreenY()
    local tapListener = TypeCast(listener, "EventListenerTouchTap")
    local address = tapListener:GetAddress()
    local info = UIButton.listeners[address]
    local engineObj = info.engineObj
    local son = info.son
    local widget = TypeCast(engineObj, "IUIWidget")
    print("UI_Button: xy, priority, name, visable", x, y, tapListener:GetPriority(), widget:GetName(), widget:IsVisable())
    if not widget:IsVisable() then
        return
    end
    local hitButton = widget:IsPointInRect(x, y, engineObj:GetPosX(), engineObj:GetPosY(), engineObj:GetWidth(), engineObj:GetHeight())
    print("UI_Button: hitButton", hitButton)
    if hitButton then
        engineObj:SwitchButtonState()
        if son then
            son.engineObj = engineObj
            local swallow = son:OnTap(event)
            if swallow then
                tapListener:SetSwallowed(true)
            end
        end
    end
end

return UIButton


---------------------------------------
-------------- Example ----------------
---------------------------------------
--[[
local UIButton = require("ui_button")

local ButtonImpl = UIButton:new(nil)

function ButtonImpl:new(engineObj)
    local o = UIButton:new(engineObj, ButtonImpl)
    setmetatable(o, self)
    self.__index = self
    print("ButtonImpl: new success")
    return o
end

function ButtonImpl:OnTap(event)
    -- 业务逻辑
end

return ButtonImpl
--]]