require("uiwidget")

local UISlider = UIWidget:new(nil)

function UISlider:new(engineObj, son)
    self.engineObj = engineObj
    self.son = son
    local o = UIWidget:new(engineObj)
    setmetatable(o, self)
    self.__index = self
    if engineObj then
        local widget = TypeCast(self.engineObj, "IUIWidget")
        local context = TypeCast(TypeCast(widget:GetParentWindow(), "CUIWindow"), "CResObj"):GetEngineContext()
	    self.listener = context:GetEventSystem():CreateAndRegEventListenerTouchSwipe(self.OnSwipeBeginCallback, self.OnSwipeCallback, self.OnSwipeEndCallback)
        self.listener:SetPriority(widget:GetListenerPriority())
    end
    print("UISlider: new success")
    return o
end

function UISlider.OnSwipeBeginCallback(event)
    local x, y = event:GetScreenX(), event:GetScreenY()
    local widget = UISlider.engineObj
    
    local slider = TypeCast(widget, "CUISlider")
    if widget:IsVisable() then
        local sliderPosX =  slider:GetPosX() - (widget:GetWidth() - slider:GetSliderWidth()) * 0.5 + (widget:GetWidth() - slider:GetSliderWidth() ) * slider:GetSliderPos()
        local hit = widget:IsPointInRect(x, y, sliderPosX, slider:GetPosY(), slider:GetSliderWidth(), slider:GetSliderHeight())
        if hit then
            if UISlider.son then
                return UISlider.son:OnSwipeBegin(event)
            else
                return false
            end
        end
    end
    return false
end

function UISlider.OnSwipeCallback(event)
    local x, y = event:GetScreenX(), event:GetScreenY()
    local widget = UISlider.engineObj
    local slider = TypeCast(widget, "CUISlider")

    local width = g_game.screenWidth
    local pos = V2i(x * g_game.screenWidth, (1 - y) * g_game.screenHeight) -- TODO
    slider:SetSliderPixelPos(pos)
    if UISlider.son then
        return UISlider.son:OnSwipe(event)
    end
end

function UISlider.OnSwipeEndCallback(event)
    if UISlider.son then
        UISlider.son:OnSwipeEnd(event)
    end
end

return UISlider


---------------------------------------
-------------- Example ----------------
---------------------------------------
--[[
local UISlider = require("ui_slider")

local SliderImpl = UISlider:new(nil)

function SliderImpl:new(engineObj)
    local o = UISlider:new(engineObj, SliderImpl)
    setmetatable(o, self)
    self.__index = self
    print("SliderImpl: new success")
    return o
end

function SliderImpl:OnSwipeBegin(event)
    print("SliderImpl: OnSwipeBegin, xy:", event:GetScreenX(), event:GetScreenY())
    return true
end

function SliderImpl:OnSwipe(event)
    print("SliderImpl: OnSwipe, xy:", event:GetScreenX(), event:GetScreenY())
    return true
end

function SliderImpl:OnSwipeEnd(event)
    print("SliderImpl: OnSwipeEnd, xy:", event:GetScreenX(), event:GetScreenY())
end

return SliderImpl
--]]