require("uiwidget")

local TouchGestureEngine = require "touch_gesture_engine/touch_gesture_engine"
local TouchGestureEngineConf = [[
    [
      {
        "detector": "tap",
        "config": {
          
        }
      }
    ]
]]


local TouchGestureListener = {
    _objList = {},
}
TouchGestureEngine:RegListener(TouchGestureEngineConf, TouchGestureListener)
print("=== reg button listener")

function TouchGestureListener:OnTap(oe)
    print("UIButton: OnTap, xy, obj size:", oe.x, oe.y, #self._objList)
    local visableObjList = {}
    for i, obj in ipairs(self._objList) do -- OnClick may modify visable state
        local widget = TypeCast(obj.engineObj, "IUIWidget")
        if widget:IsVisable() then
            table.insert(visableObjList, obj)
        end
    end
    for i, obj in ipairs(visableObjList) do
        local hitButton = TypeCast(obj.engineObj, "IUIWidget"):IsPointInRect(oe.x, oe.y, obj.engineObj:GetPosX(), obj.engineObj:GetPosY(), obj.engineObj:GetWidth(), obj.engineObj:GetHeight())
        if hitButton then
            if obj:OnClick(oe) then
                break
            end
        end
    end
end

UIButton = UIWidget:new(nil)

function UIButton:new(engineObj)
    local o = UIWidget:new(engineObj)
    setmetatable(o, self)
    self.__index = self

    -- engineObj:GetLogicObjProxy():RegBoolProperty("关节连线贴图", "")

    -- if engineObj then
    --     TouchGestureListener.obj = o
    --     TouchGestureEngine:RegListener(TouchGestureEngineConf, TouchGestureListener)
    -- end
    print("UIButton: new success")
    return o
end

-- virtual function
-- input
-- oe.x: x coordinate which in [0-1]
-- oe.y: y coordinate which in [0-1]
function UIButton:OnClick(oe)
    print("UIButton: default OnClick, xy:", oe.x, oe.y)
end

function UIButton:AddObj(obj)
    table.insert(TouchGestureListener._objList, obj)
    print("Button: add obj, xy", obj.engineObj:GetPosX(), obj.engineObj:GetPosY())
end

return UIButton