
UIMgr = {}

function UIMgr:new(context)
    o = {}
    setmetatable(o, self)
    self.__index = self
    o.uiObjs = {}
    o.context = context
    o.resMgr = context:GetResMgr()
    return o
end

function UIMgr:createUI(strPath)
    local engineObjPtr = self.resMgr:CreateResObj(strPath, nil, false)
    g_Game:createLogicObj(engineObjPtr:Get():GetLuaPath(), engineObjPtr:Get(), nil)
    local obj = g_Game:findLogicObj(engineObjPtr:Get())
    if obj then
        self.uiObjs[engineObjPtr:Get():GetAddress()] = {logicObj = obj, engineObj = engineObjPtr}
        return engineObjPtr:Get()
    end

    return nil
end


function UIMgr:removeUI(engineObj)
    self.uiObjs[engineObj:GetAddress()] = nil
end

function UIMgr:render(time)
    for k, v in pairs(self.uiObjs) do
        if v then
            v:Render(time)
        end
    end
end

return UIMgr