require("uiwidget")

local TouchGestureEngine = require "touch_gesture_engine/touch_gesture_engine"
local TouchGestureEngineConf = [[
    [
      {
        "detector": "swipe",
        "config": {
          
        }
      }
    ]
]]


local TouchGestureListener = {
    _objList = {},
}
TouchGestureEngine:RegListener(TouchGestureEngineConf, TouchGestureListener)

function TouchGestureListener:OnSwipeBegin(oe)
    print("UISlider: OnSwipeBegin, xy", oe.x, oe.y)
    local widget = self.obj.engineObj
    
    local slider = TypeCast(widget, "CUISlider")
    print(111, slider)
    if widget:IsVisable() then
        local sliderPosX =  slider:GetPosX() - (widget:GetWidth() - slider:GetSliderWidth()) * 0.5 + (widget:GetWidth() - slider:GetSliderWidth() ) * slider:GetSliderPos()
        print("UISlider: window width", widget:GetParentWindow():GetEditorScreenWidth(), "slider pos", slider:GetSliderPos(), "slider width", widget:GetWidth(), "slider pos x", sliderPosX)
        local hit = widget:IsPointInRect(oe.x, oe.y, sliderPosX, slider:GetPosY(), slider:GetSliderWidth(), slider:GetSliderHeight())
        if hit then
            print("UISlider: hit")
            return true
        end
    end
    return false
end

function TouchGestureListener:OnSwipe(oe)
    print("UISlider: OnSwipe, xy", oe.x, oe.y)
    local widget = self.obj.engineObj
    local slider = TypeCast(widget, "CUISlider")
    -- local sliderHalfWidth = (widget:GetWidth() - slider:GetSliderWidth()) / 2 -- widget:GetWidth() / 2
    -- local screenWidth = widget:GetParentWindow():GetEditorScreenWidth()
    -- local sliderPixelPos = sliderHalfWidth - (screenWidth * (0.5 - oe.x))
    -- local newPos = sliderPixelPos / (sliderHalfWidth * 2)
    -- newPos = math.max(newPos, 0)
    -- newPos = math.min(newPos, 1)
    -- print("UISlider: touch x", oe.x, "sliderHalfWidth", sliderHalfWidth, "screenWidth", screenWidth, "sliderPixelPos", sliderPixelPos, "new pos", newPos)
    -- slider:SetSliderPos(newPos)
    -- oe.sliderPos = newPos

    local width = g_game.screenWidth
    local pos = V2i(oe.x * g_game.screenWidth, (1 - oe.y) * g_game.screenHeight)
    -- local pos = V2i(oe.x * g_game.screenWidth, oe.y * g_game.screenHeight)
    slider:SetSliderPixelPos(pos)
    self.obj:OnSwipe(oe)
end

function TouchGestureListener:OnSwipeEnd(oe)
    self.obj:OnSwipeEnd(oe)
    print("UISlider: in OnSwipeEnd")
end

UISlider = UIWidget:new(nil)

function UISlider:new(engineObj)
    local o = UIWidget:new(engineObj)
    setmetatable(o, self)
    self.__index = self
    print("UISlider: new success")
    return o
end

-- virtual function
-- input
-- oe.x: x coordinate which in [0-1]
-- oe.y: y coordinate which in [0-1]
-- oe.deltaX: delat x, x in [0-1] 
-- oe.deltaY: delat y, y in [0-1] 
function UISlider:OnSwipe(oe)
    print("UISlider: default OnSwipe, xy:", oe.x, oe.y)
end

function UISlider.SetObj(obj)
    TouchGestureListener.obj = obj
end

return UISlider