MiscUtil = {}

function MiscUtil.TableLength(t)
    local count = 0  
    for k,v in pairs(t) do  
        count = count + 1  
    end  
    return count
end

function MiscUtil.CallIfNotNil(obj, fun)
    if obj[fun] ~= nil then
        obj[fun](obj)
    end
end

function MiscUtil.DeepCopy(object)      
    local SearchTable = {}  

    local function Func(object)  
        if type(object) ~= "table" then  
            return object         
        end  
        local NewTable = {}  
        SearchTable[object] = NewTable  
        for k, v in pairs(object) do  
            NewTable[Func(k)] = Func(v)  
        end     
       
        return setmetatable(NewTable, getmetatable(object))      
    end    
  
    return Func(object)  
end  

function MiscUtil.PrintTable(t)
    local print_r_cache={}
    local function sub_print_r(t,indent)
        if (print_r_cache[tostring(t)]) then
            print(indent.."*"..tostring(t))
        else
            print_r_cache[tostring(t)]=true
            if (type(t)=="table") then
                for pos,val in pairs(t) do
                    if (type(val)=="table") then
                        print(indent.."["..pos.."] => "..tostring(t).." {")
                        sub_print_r(val,indent..string.rep(" ",string.len(pos)+8))
                        print(indent..string.rep(" ",string.len(pos)+6).."}")
                    elseif (type(val)=="string") then
                        print(indent.."["..pos..'] => "'..val..'"')
                    else
                        print(indent.."["..pos.."] => "..tostring(val))
                    end
                end
            else
                print(indent..tostring(t))
            end
        end
    end
    if (type(t)=="table") then
        print(tostring(t).." {")
        sub_print_r(t,"  ")
        print("}")
    else
        sub_print_r(t,"  ")
    end
    print()
end

function MiscUtil.PrintMatrix(m)
    print("line_1: ", m.m11, m.m12, m.m13, m.m14)
    print("line_2: ", m.m21, m.m22, m.m23, m.m24)
    print("line_3: ", m.m31, m.m32, m.m33, m.m34)
    print("line_4: ", m.m41, m.m42, m.m43, m.m44)
end

return MiscUtil
