StringUtil = {}

function StringUtil.Split(s, p, trim)
    local rt= {}
    string.gsub(s, '[^'..p..']+', function(w) table.insert(rt, w) end )
    if trim then
        for i, v in ipairs(rt) do
            -- rt[i] = string.gsub(v, "%s+", "")
            rt[i] = (string.gsub(v, "^%s*(.-)%s*$", "%1"))
        end
    end
    return rt
end

function StringUtil.UrlEncode(s)  
    s = string.gsub(s, "([^%w%.%- ])", function(c) return string.format("%%%02X", string.byte(c)) end)  
    return string.gsub(s, " ", "+")  
end  

function StringUtil.UrlDecode(s)  
    s = string.gsub(s, '%%(%x%x)', function(h) return string.char(tonumber(h, 16)) end)  
    return s  
end  

-- local a = StringUtil.Split(" 1 2\t ,333", ",", true)
-- for i, v in ipairs(a) do
--     print("[" .. v .. "]")
-- end

return StringUtil