 varying highp vec2 vTexCoord;
 varying highp vec2 leftTextureCoordinate;
 varying highp vec2 rightTextureCoordinate;
 varying highp vec2 topTextureCoordinate;
 varying highp vec2 bottomTextureCoordinate;
 varying highp float centerMultiplier;
 varying highp float edgeMultiplier;

 uniform lowp float brightness;
 uniform sampler2D colorMap;

 void main()
 {
    lowp vec3 textureColor = texture2D(colorMap, vTexCoord).rgb;
    lowp vec3 leftTextureColor = texture2D(colorMap, leftTextureCoordinate).rgb;
    lowp vec3 rightTextureColor = texture2D(colorMap, rightTextureCoordinate).rgb;
    lowp vec3 topTextureColor = texture2D(colorMap, topTextureCoordinate).rgb;
    lowp vec3 bottomTextureColor = texture2D(colorMap, bottomTextureCoordinate).rgb;
    lowp vec4 color = vec4((textureColor * centerMultiplier - (leftTextureColor * edgeMultiplier + rightTextureColor * edgeMultiplier + topTextureColor * edgeMultiplier + bottomTextureColor * edgeMultiplier)), texture2D(colorMap, bottomTextureCoordinate).w);
    gl_FragColor = vec4(mix(textureColor, color.rgb + vec3(brightness), 0.5), 1.0);
}