 attribute vec4 position;
 attribute vec4 inputTextureCoordinate;

 varying vec2 vTexCoord;
 varying vec2 leftTextureCoordinate;
 varying vec2 rightTextureCoordinate;
 varying vec2 topTextureCoordinate;
 varying vec2 bottomTextureCoordinate;
 varying float centerMultiplier;
 varying float edgeMultiplier;

 uniform float imageWidthOffset;
 uniform float imageHeightOffset;
 uniform float sharpness;

 void main()
 {
    gl_Position = position;

    highp vec2 widthStep = vec2(imageWidthOffset, 0.0);
    highp vec2 heightStep = vec2(0.0, imageHeightOffset);

    vTexCoord = inputTextureCoordinate.xy;
    leftTextureCoordinate = inputTextureCoordinate.xy - widthStep;
    rightTextureCoordinate = inputTextureCoordinate.xy + widthStep;
    topTextureCoordinate = inputTextureCoordinate.xy + heightStep;
    bottomTextureCoordinate = inputTextureCoordinate.xy - heightStep;

    centerMultiplier = 1.0 + 4.0 * sharpness;
    edgeMultiplier = sharpness;
}
